--------------------------------------------
-- @Author  : htp
-- @Editor  : htp
-- @Date    : 2019-08-13 15:36:39
-- @description    : 
		-- 精灵主界面
---------------------------------
ElfinRousePanel = class("ElfinRousePanel",function()
    return ccui.Layout:create()
end)

local _controller = ElfinController:getInstance()
local _model = _controller:getModel()
local _table_insert = table.insert
local _table_sort = table.sort
local _string_format = string.format

function ElfinRousePanel:ctor()
	self.root_wnd = createCSBNote(PathTool.getTargetCSB("hero/hero_elfin_rouse_panel"))

    self.size = self.root_wnd:getContentSize()
    self:setContentSize(self.size)

    self.root_wnd:setAnchorPoint(0.5, 0.5)
    self.root_wnd:setPosition(self.size.width * 0.5, self.size.height * 0.5)
    self:addChild(self.root_wnd)

    -- 初始化数据
    self:initElfinData()

    -- 资源加载
    local res_list = {}
    _table_insert(res_list, {path = PathTool.getPlistImgForDownLoad("gw_hero_elfin", "gw_hero_elfin"), type = ResourcesType.plist})
    if self.init_res_load then
        self.init_res_load:DeleteMe()
        self.init_res_load = nil
    end
    self.init_res_load = ResourcesLoad.New()
    self.init_res_load:addAllList(res_list, function()
        if not tolua.isnull(self.root_wnd) then
            self:loadResListCompleted()
        end
    end)
end

function ElfinRousePanel:loadResListCompleted( )
	self:initView()
    self:registerEvent()

    self:changeSelectedTab()
    --self:updateElfinRedInfo()
end


-- 初始化数据
function ElfinRousePanel:initElfinData(  )
    
    --self.tree_elfin_list = {} -- 古树的四个精灵
    --self.tree_skill_list = {} -- 古树的技能图标
    --self.tree_attr_list = {}  -- 古树的属性
    self.tree_step_max = false  -- 古树是否达到当前阶级的最大等级
    self.tree_is_max_step = false -- 古树是否达到最大阶数
end

-- 初始化界面
function ElfinRousePanel:initView(  )
	self.container = self.root_wnd:getChildByName("container")
    self.rouse_panel = self.container:getChildByName("rouse_panel")
    self.rouse_rule_btn = self.rouse_panel:getChildByName("rouse_rule_btn")
    self.rouse_rule_btn:setPositionX(display.getLeft() + 327)
    self.rouse_rule_btn:setPositionY(display.getTop() - 35)
    self.rouse_rule_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            self:onClickRouseRuleBtn(param, sender, event_type)
        end
    end)
    self.hole_infos = self.rouse_panel:getChildByName("hole_infos")
    self.right_infos = self.rouse_panel:getChildByName("right_infos")
    self.hole_item_list = {}
    for i=1,4 do
        local item = self.hole_infos:getChildByName("hole_item"..i)
        item.spine_node = item:getChildByName("spine_node")
        item.spine_node:setVisible(false)
        item.star = item:getChildByName("star")
        item.star:setVisible(false)
        item.add = item:getChildByName("add")
        item.add:setVisible(false)
        item.empty_name_bg = item:getChildByName("empty_name_bg")
        item.empty_name_bg:setVisible(false)
        item.name = item:getChildByName("name")
        item.redpoint = item:getChildByName("redpoint")
        item.redpoint:setVisible(false)
        self.hole_item_list[i] = item
        self.hole_item_list[i]:addTouchEventListener(function(sender, event_type)
            customClickAction_4(sender, event_type)
            if event_type == ccui.TouchEventType.ended then
                playButtonSound2()
                self:onClickHoleItem(i)
            end
        end)
    end
    self.power_click = self.hole_infos:getChildByName("power_click")
    self.score_title = self.power_click:getChildByName("score_title")
    self.score_title:setString(UI_TI18N(70008))
    --self.fight_label = CommonNum.new(20, self.score_title, 99999, - 2, cc.p(0, 0.5))
    --self.fight_label:setPosition(self.score_title:getContentSize().width + 5, 29)
    self.fight_label = CommonNum.new(103, self.score_title, 34567, -5, cc.p(0, 0.5))
    self.fight_label:setPosition(self.score_title:getContentSize().width+5, 30)
    self.fight_label:setScale(0.77)
    self.fight_label:setCallBack(function()
        local num_width = self.fight_label:getContentSize().width * 0.77
        local total_width = self.fight_label:getPositionX() + num_width
        self.score_title:setPositionX(159 - total_width/2)
    end)
    self.fight_label:setNum(0)

    self.skill_bg = self.right_infos:getChildByName("skill_bg")
    self.skill_title = self.skill_bg:getChildByName("skill_title")
    self.skill_title:setString(UI_TI18N(70009))
    self.adjust_btn = self.skill_bg:getChildByName("adjust_btn")
    self.adjust_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            self:onClickAdjustBtn()
        end
    end)
    self.skill_item_list = {}
    for i=1,4 do
        local item = self.skill_bg:getChildByName("skill"..i)
        item.skill_item = item:getChildByName("item")
        item.skill_item:setVisible(false)
        item.skill_item_icon = item.skill_item:getChildByName("icon")
        item.skill_item_lev_label = item.skill_item:getChildByName("lev_label")
        item.add = item:getChildByName("add")
        item.add:setVisible(false)
        item.locked = item:getChildByName("locked")
        item.locked:setVisible(false)
        item.pos = item:getChildByName("pos")
        item.pos:setString(i)
        item.name = item:getChildByName("name")
        self.skill_item_list[i] = item
        self.skill_item_list[i]:addTouchEventListener(function(sender, event_type)
            customClickAction_4(sender, event_type)
            if event_type == ccui.TouchEventType.ended then
                playButtonSound2()
                self:onClickSkillItem(i)
            end
        end)
    end

    self.rouse_lv_title = self.right_infos:getChildByName("rouse_lv_title")
    StringUtil.gw_setLabelContent(self.rouse_lv_title, UI_TI18N(70010), 220)
    self.lev_bar = self.right_infos:getChildByName("lev_bar")
    self.lev_bar:setScale9Enabled(true)
    self.lev_bar:setPercent(0)
    self.rouse_lv_txt = self.right_infos:getChildByName("rouse_lv_txt")
    self.rouse_step_title = self.right_infos:getChildByName("rouse_step_title")
    StringUtil.gw_setLabelContent(self.rouse_step_title, UI_TI18N(70011), 220)

    self.stage_infos = self.right_infos:getChildByName("stage_infos")
    self.stage_label = self.stage_infos:getChildByName("stage_label")
    StringUtil.gw_setLabelContent(self.stage_label, UI_TI18N(70012), 70)
    self.stage_con = self.stage_infos:getChildByName("stage_con")
    self.stage_item_list = {}
    for i=1,12 do
        local item = {}
        item.bg = self.stage_con:getChildByName("bg"..i)
        item.bg:setVisible(false)
        item.icon = self.stage_con:getChildByName("stage"..i)
        item.icon:setVisible(false)
        self.stage_item_list[i] = item
    end

    self.rouse_attr_title = self.right_infos:getChildByName("rouse_attr_title")
    StringUtil.gw_setLabelContent(self.rouse_attr_title, UI_TI18N(70013), 220)

    self.rouse_attr_item_list = {}
    for i=1,4 do
        local item = self.right_infos:getChildByName("rouse_attr"..i)
        item:setVisible(false)
        item.icon = item:getChildByName("icon")
        item.label = item:getChildByName("label")
        self.rouse_attr_item_list[i] = item
    end

    self.rouse_btn = self.right_infos:getChildByName("rouse_btn")
    self.rouse_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            self:onClickRouseBtn()
        end
    end)
    self.rouse_btn:setTouchEnabled(false)
    self.rouse_btn_label = self.rouse_btn:getChildByName("label")
    self.rouse_btn_redpoint = self.rouse_btn:getChildByName("redpoint")
    self.rouse_btn_redpoint:setVisible(false)

    self.cost_item_list = {}
    for i=1,2 do
       local item = self.right_infos:getChildByName("cost"..i)
        item:setVisible(false)
        item.icon = item:getChildByName("icon")
        item.num1 = item:getChildByName("num1")
        item.num2 = item:getChildByName("num2")
        self.cost_item_list[i] = item
    end





    --self.elfin_book_txt = createRichLabel(24, cc.c4b(155,67,9,255), cc.p(0.5, 0.5), cc.p(621, 850))
    --self.container:addChild(self.elfin_book_txt)
    --self.elfin_book_txt:setString(_string_format(TI18N("<div href=xxx >传记 </div><img src='%s'/>"), PathTool.getResFrame("elfin","elfin_1016")))
    --self.elfin_book_txt:addTouchEventListener(function (  )
    --    local tree_story_cfg = Config.SpriteData.data_const["ancient_story"]
    --    if tree_story_cfg then
    --        HeroController:getInstance():openHeroLibraryStoryPanel(true, TI18N("魔导机器装配间"), tree_story_cfg.desc)
    --    end
    --end)

    ---- 唤醒
    --self.rouse_panel = self.container:getChildByName("rouse_panel")
    --self.rouse_panel:getChildByName("rouse_name_txt"):setString(TI18N("魔导机器装配间"))
    --self.rouse_panel:getChildByName("rouse_tips"):setString(TI18N("魔导机器人在装配间中装配上阵，帮助英雄们进行战斗"))
    --self.rouse_panel:getChildByName("skill_title"):setString(TI18N("释放顺序:"))
    --self.rouse_panel:getChildByName("rouse_lv_title"):setString(TI18N("装配间等级:"))
    --self.rouse_panel:getChildByName("rouse_step_title"):setString(TI18N("装配间星级:"))
    --
    --self.rouse_bg = self.rouse_panel:getChildByName("rouse_bg")
    --self.rouse_bg:ignoreContentAdaptWithSize(true)
    --self.rouse_lv_txt = self.rouse_panel:getChildByName("rouse_lv_txt")
    --self.rouse_step_txt = self.rouse_panel:getChildByName("rouse_step_txt")
    --
    --self.power_click = self.rouse_panel:getChildByName("power_click")
    --self.score_title = self.power_click:getChildByName("score_title")
    --self.score_title:setString(TI18N("评分："))
    --self.fight_label = CommonNum.new(20, self.power_click, 99999, - 2, cc.p(0.5, 0.5))
    --self.fight_label:setPosition(103, 29)
    --
    --self.rouse_rule_btn = self.rouse_panel:getChildByName("rouse_rule_btn")
    --self.rouse_btn = self.rouse_panel:getChildByName("rouse_btn")
    --self.rouse_btn_label = self.rouse_btn:getChildByName("label")
    --self.rouse_btn_label:setString(TI18N("升级"))
    --self.adjust_btn = self.rouse_panel:getChildByName("adjust_btn")
    --
    --self.max_lv_sp = self.rouse_panel:getChildByName("max_lv_sp")
    --self.rouse_cost_panel = self.rouse_panel:getChildByName("cost_panel")
    --self.cost_objects = {}
    --for i=1,2 do
    --    local object = {}
    --    object.cost_bg = self.rouse_cost_panel:getChildByName("cost_bg_" .. i)
    --    object.res_icon = self.rouse_cost_panel:getChildByName("cost_res_icon_" .. i)
    --    object.cost_txt = self.rouse_cost_panel:getChildByName("cost_txt_" .. i)
    --    _table_insert(self.cost_objects, object)
    --end
end

function ElfinRousePanel:registerEvent(  )

    --registerButtonEventListener(self.rouse_btn, function (  )
    --    self:onClickRouseBtn()
    --end, true)
    --
    --
    --registerButtonEventListener(self.adjust_btn, function (  )
    --    self:onClickAdjustBtn()
    --end, true)
    --
    --
    -- 复苏/唤醒
    self.rouse_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.began then
            if GuideController:getInstance():isInGuide() or self.tree_is_max_step == true then return end
            if not self.tree_step_max then -- 复苏支持长按
                local action = cc.Sequence:create(cc.DelayTime:create(0.3), cc.CallFunc:create(function()
                    self:startTimeTicket()
                end))
                self.sequence_action = self.rouse_btn:runAction(action)
                self.sequence_action:setTag(10086)
            end
        elseif event_type == ccui.TouchEventType.canceled then
            self:clearTimeTicket()
        elseif event_type == ccui.TouchEventType.ended then
            self:clearTimeTicket()
            self:onClickRouseBtn()
        end
    end)
    --
    --registerButtonEventListener(self.rouse_rule_btn, function ( param, sender, event_type )
    --    self:onClickRouseRuleBtn(param, sender, event_type)
    --end, true, nil, nil, 0.8)



    -- 古树信息
    if not self.get_tree_data_event then
        self.get_tree_data_event = GlobalEvent:getInstance():Bind(ElfinEvent.Get_Elfin_Tree_Data_Event, function ( )
            self:updateRouseInfo()
        end)
    end

    -- 古树升级成功
    if not self.tree_up_lv_event then
        self.tree_up_lv_event = GlobalEvent:getInstance():Bind(ElfinEvent.Elfin_Tree_Lv_Up_Event, function ( )
           
        end)
    end


    -- 物品数量变化
    if not self.add_goods_event then
        self.add_goods_event = GlobalEvent:getInstance():Bind(BackpackEvent.ADD_GOODS, function(bag_code, item_list)
            if bag_code ~= BackPackConst.Bag_Code.BACKPACK then return end
            self:checkNeedUpdateItemNum(item_list)
        end)
    end
    if not self.del_goods_event then
        self.del_goods_event = GlobalEvent:getInstance():Bind(BackpackEvent.DELETE_GOODS, function(bag_code, item_list)
            if bag_code ~= BackPackConst.Bag_Code.BACKPACK then return end
            self:checkNeedUpdateItemNum(item_list)
        end)
    end
    if not self.modify_goods_event then
        self.modify_goods_event = GlobalEvent:getInstance():Bind(BackpackEvent.MODIFY_GOODS_NUM, function(bag_code, item_list)
            if bag_code ~= BackPackConst.Bag_Code.BACKPACK then return end
            self:checkNeedUpdateItemNum(item_list)
        end)
    end

    -- 红点
    if not self.update_red_status_event then
        self.update_red_status_event = GlobalEvent:getInstance():Bind(ElfinEvent.Update_Elfin_Red_Event, function ( bid, status )
            self:updateElfinRedInfo(bid, status)
        end)
    end
end

function ElfinRousePanel:changeSelectedTab()
    self:updateRouseInfo()
    if not self.init_rouse_flag then
        self.init_rouse_flag = true
        _controller:sender26510() -- 第一次切换标签页时请求古树信息
    end
end


---------------------@ 精灵古树相关
-- 更新古树
function ElfinRousePanel:updateRouseInfo(  )
    
    self.elfin_tree_data = _model:getElfinTreeData()

    if not self.elfin_tree_data or next(self.elfin_tree_data) == nil then return end

    local level_cfg = Config.SpriteData.data_tree_up_lv(self.elfin_tree_data.lev)
    local step_cfg = Config.SpriteData.data_tree_step[self.elfin_tree_data.break_lev]
    if not step_cfg or not level_cfg then return end

    self.fight_label:setNum(self.elfin_tree_data.power)

    --四个精灵位置和技能
    for i=1,4 do
        local elfin_bid = self:getTreeElfinBidByPos(i)
        local skill_item = self.skill_item_list[i]
        local hole_item = self.hole_item_list[i]
        if elfin_bid then
            skill_item.locked:setVisible(false)
            local elfin_cfg = Config.SpriteData.data_elfin_data(elfin_bid)
            if elfin_bid == 0 or not elfin_cfg then -- 已解锁，但未放置精灵
                local name_str = UI_TI18N(70014)
                StringUtil.gw_setLabelContent(skill_item.name, name_str, 120)
                StringUtil.gw_setLabelContent(hole_item.name, name_str, 150)

                skill_item.skill_item:setVisible(false)
                skill_item.add:setVisible(true)

                hole_item.spine_node:setVisible(false)
                hole_item.star:setVisible(false)
                hole_item.add:setVisible(true)
                hole_item.empty_name_bg:setVisible(false)
            else
                local skill_cfg = Config.SkillData.data_get_skill(elfin_cfg.skill)
                if skill_cfg then
                    StringUtil.gw_setLabelContent(skill_item.name, skill_cfg.name, 120)
                    local skill_icon = PathTool.getSkillRes(skill_cfg.icon, false)
                    PathTool.gw_setSkillIconForImage(skill_item.skill_item_icon, skill_item.skill_item_icon_load, skill_icon)
                    --skill_item.skill_item_icon:loadTexture(skill_icon, LOADTEXT_TYPE)
                    local lev_str = ""
                    if skill_cfg.client_lev and skill_cfg.client_lev > 0 then
                        lev_str = string.format("Lv.%d", skill_cfg.client_lev)
                    elseif skill_cfg.level and skill_cfg.level > 0 then
                        lev_str = string.format("Lv.%d", skill_cfg.level)
                    end
                    skill_item.skill_item_lev_label:setString(lev_str)
                else
                    Debug.error("找不到精灵技能配置！！ID:"..elfin_cfg.skill)
                end

                skill_item.skill_item:setVisible(true)
                skill_item.add:setVisible(false)


                local spine_res = elfin_cfg.effect_id
                if hole_item.spine_res == nil or hole_item.spine_res ~= spine_res then
                    if hole_item.spine then
                        hole_item.spine:setVisible(false)
                        hole_item.spine:removeFromParent()
                        hole_item.spine = nil
                    end
                    hole_item.spine_res = spine_res
                    hole_item.spine = gw_createEffectSpine(spine_res, cc.p(0,0) , cc.p(0.5,0),true, PlayerAction.gw_idle,nil, cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888)
                    hole_item.spine_node:addChild(hole_item.spine)
                end
                local offset_y = tonumber(elfin_cfg.offset_y) or 0
                local scale = elfin_cfg.scale_val or 1000
                hole_item.spine:setPositionY(offset_y)
                hole_item.spine_node:setScale(scale/1000)

                local star = elfin_cfg.step or 1
                if star < 1 then star = 1 end
                if star > 10 then star = 10 end
                loadSpriteTexture(hole_item.star, PathTool.gw_getStarCommon01(star), LOADTEXT_TYPE_PLIST)

                local item_cfg = Config.ItemData.data_get_data(elfin_bid)
                if item_cfg then
                    StringUtil.gw_setLabelContent(hole_item.name, item_cfg.name, 150)
                else
                    Debug.error("找不到精灵道具配置！！ID:"..elfin_bid)
                end

                hole_item.spine_node:setVisible(true)
                hole_item.star:setVisible(true)
                hole_item.add:setVisible(false)
                hole_item.empty_name_bg:setVisible(false)
            end
        else
            --未解锁精灵位置
            skill_item.skill_item:setVisible(false)
            skill_item.add:setVisible(false)
            skill_item.locked:setVisible(true)
            local locked_tips = ""
            local need_step = Config.SpriteData.data_tree_limit[i]
            if need_step then
                locked_tips = StringFormat(UI_TI18N(70015), need_step)
            end
            StringUtil.gw_setLabelContent(skill_item.name, locked_tips, 120)
            StringUtil.gw_setLabelContent(hole_item.name, locked_tips, 150)

            hole_item.spine_node:setVisible(false)
            hole_item.star:setVisible(false)
            hole_item.add:setVisible(true)
            hole_item.empty_name_bg:setVisible(true)
        end

        local elfin_info = {}
        elfin_info.elfin_bid = elfin_bid
        elfin_info.elfin_pos = i
        elfin_info.need_step = Config.SpriteData.data_tree_limit[i]
        hole_item.elfin_info = elfin_info
    end

    -- 复苏等级
    self.rouse_lv_txt:setString(self.elfin_tree_data.lev .. "/" .. step_cfg.lev_max)
    self.lev_bar:setPercent(100*self.elfin_tree_data.lev/step_cfg.lev_max)
    -- 唤醒阶段
    local max_step = 0
    if Config.SpriteData.data_tree_step then
        for i,v in pairs(Config.SpriteData.data_tree_step) do
            if v.count > max_step then
                max_step = v.count
            end
        end
    end

    for i=1, self.elfin_tree_data.break_lev do
        local item = self.stage_item_list[i]
        if item then
            item.bg:setVisible(false)
            item.icon:setVisible(true)
        end
    end
    for i=self.elfin_tree_data.break_lev+1, max_step do
        local item = self.stage_item_list[i]
        if item then
            item.bg:setVisible(true)
            item.icon:setVisible(false)
        end
    end
    for i=max_step + 1, #self.stage_item_list do
        local item = self.stage_item_list[i]
        if item then
            item.bg:setVisible(false)
            item.icon:setVisible(false)
        end
    end

    if self.elfin_tree_data.lev >= Config.SpriteData.data_tree_up_lv_length then
        self.tree_is_max_step = true
        for i,v in pairs(self.cost_item_list) do
            v:setVisible(false)
        end
        self.rouse_btn:setTouchEnabled(false)
        StringUtil.gw_setLabelContent(self.rouse_btn_label, UI_TI18N(70016), 220)
        setChildUnEnabled(true, self.rouse_btn)
        self.rouse_btn_label:disableEffect(cc.LabelEffect.OUTLINE)
    else
        for i,v in pairs(self.cost_item_list) do
            v:setVisible(false)
        end
        local label_str = ""
        if self.elfin_tree_data.lev >= step_cfg.lev_max then -- 达到当前阶级最大等级，显示为唤醒
            label_str = UI_TI18N(70017)

            self.tree_step_max = true
            self.tree_is_max_step = false

            -- 消耗
            if step_cfg.expend then
                for i,v in ipairs(step_cfg.expend) do
                    local item_bid = v[1]
                    local item_num = v[2]
                    if i == 1 then
                        self.cost_item_bid_1 = item_bid
                        self.cost_item_need_num_1 = item_num
                    elseif i == 2 then
                        self.cost_item_bid_2 = item_bid
                        self.cost_item_need_num_2 = item_num
                    end
                    self:showTreeCostInfo(true, i, item_bid, item_num)
                end
            end
        else -- 未达到当前阶级最大等级，显示为复苏
            label_str = UI_TI18N(70018)

            self.tree_step_max = false
            if level_cfg.expend then
                for i,v in ipairs(level_cfg.expend) do
                    local item_bid = v[1]
                    local item_num = v[2]
                    if i == 1 then
                        self.cost_item_bid_1 = item_bid
                        self.cost_item_need_num_1 = item_num
                    elseif i == 2 then
                        self.cost_item_bid_2 = item_bid
                        self.cost_item_need_num_2 = item_num
                    end
                    self:showTreeCostInfo(true, i, item_bid, item_num)
                end
            end
        end

        self.rouse_btn:setTouchEnabled(true)
        StringUtil.gw_setLabelContent(self.rouse_btn_label, label_str, 220)
        setChildUnEnabled(false, self.rouse_btn)
        self.rouse_btn_label:enableOutline(cc.c4b(0xbd,0x70,0x15,0xff), 2)
    end

    -- 属性
    for k,txt in pairs(self.rouse_attr_item_list) do
        txt:setVisible(false)
    end
    for i,attr_key in ipairs(ElfinConst.Tree_Attrs) do
        local attr_val = self.elfin_tree_data[attr_key]
        -- 是否为百分比
        if PartnerCalculate.isShowPerByStr(attr_key) then
            attr_val = (attr_val/100).."%"
        end
        local item = self.rouse_attr_item_list[i]
        if item then
            item.label:setString(attr_val)
            PathTool.gw_setAttrIcon(item.icon, attr_key)
            item:setVisible(true)
        end
    end

    self:updateElfinRedInfo()


    ---- 背景
    --local tree_bg_res = PathTool.getElfinTreeBgRes(step_cfg.res_id)
    --if not self.cur_tree_bg_res or self.cur_tree_bg_res ~= tree_bg_res then
    --    self.cur_tree_bg_res = tree_bg_res
    --    self.tree_bg_load = loadImageTextureFromCDN(self.rouse_bg, tree_bg_res, ResourcesType.single, self.tree_bg_load)
    --end
    --self.fight_label:setNum(self.elfin_tree_data.power)
    --
    ---- 四个精灵位置和技能
    --local cd_order = 0
    --for i=1,4 do
    --    local elfin_bid = self:getTreeElfinBidByPos(i)
    --    -- 技能
    --    local skill_item = self.tree_skill_list[i]
    --    if not skill_item then
    --        skill_item = SkillItem.new(true, true, true, 0.75, true)
    --        self.rouse_panel:addChild(skill_item)
    --        skill_item:setPosition(cc.p(250+(i-1)*112, 340))
    --        self.tree_skill_list[i] = skill_item
    --    end
    --    skill_item:showNoneText(false)
    --    skill_item:setSkillFirstCd(0)
    --    if elfin_bid then
    --        skill_item:showLockIcon(false)
    --        local elfin_cfg = Config.SpriteData.data_elfin_data(elfin_bid)
    --        if elfin_bid == 0 or not elfin_cfg then -- 已解锁，但未放置精灵
    --            skill_item:setData()
    --            skill_item:showName(false)
    --            skill_item:showLevel(false)
    --            skill_item:showNoneText(true, TI18N("请先将魔导机器人在装配间上阵~"))
    --        else
    --            local skill_cfg = Config.SkillData.data_get_skill(elfin_cfg.skill)
    --            if skill_cfg then
    --                skill_item:showLevel(true)
    --                skill_item:setData(skill_cfg)
    --                skill_item:showName(true,skill_cfg.name,nil,20,true,cc.c4b(0xff,0xf0,0xd2,0xff),PathTool.getResFrame("elfin","elfin_1022"),cc.size(110,26))
    --                if skill_cfg.type == "active_skill" then -- 主动技能
    --                    cd_order = cd_order + 1
    --                    skill_item:setSkillFirstCd(cd_order)
    --                end
    --            end
    --        end
    --    else
    --        -- 未解锁精灵位置
    --        skill_item:setData()
    --        skill_item:showName(false)
    --        skill_item:showLevel(false)
    --        local need_step = Config.SpriteData.data_tree_limit[i]
    --        if need_step then
    --            skill_item:showLockIcon(true, nil, _string_format(TI18N("装配间达到%s阶解锁"), StringUtil.numToChinese(need_step)))
    --        end
    --    end
    --
    --    -- 精灵位置
    --    local elfin_item = self.tree_elfin_list[i]
    --    if not elfin_item then
    --        elfin_item = ElfinRouseItem.new()
    --        self.rouse_panel:addChild(elfin_item)
    --        local pos_x = 180 + (1-i%2)*400
    --        local pos_y = 690 - (math.ceil(i/2)-1)*160
    --        elfin_item:setPosition(cc.p(pos_x, pos_y))
    --        self.tree_elfin_list[i] = elfin_item
    --    end
    --    local elfin_info = {}
    --    elfin_info.elfin_bid = elfin_bid
    --    elfin_info.elfin_pos = i
    --    elfin_info.need_step = Config.SpriteData.data_tree_limit[i]
    --    elfin_item:setData(elfin_info)
    --end
    --
    ---- 复苏等级
    --self.rouse_lv_txt:setString(self.elfin_tree_data.lev .. "/" .. step_cfg.lev_max)
    ---- 唤醒阶段
    --self.rouse_step_txt:setString(StringUtil.numToChinese(self.elfin_tree_data.break_lev) .. TI18N("星级"))
    --
    ---- 属性
    --for k,txt in pairs(self.tree_attr_list) do
    --    txt:setVisible(false)
    --end
    --for i,attr_key in ipairs(ElfinConst.Tree_Attrs) do
    --    local attr_val = self.elfin_tree_data[attr_key]
    --    -- 是否为百分比
    --    if PartnerCalculate.isShowPerByStr(attr_key) then
    --        attr_val = (attr_val/100).."%"
    --    end
    --    local attr_txt = self.tree_attr_list[i]
    --    if not attr_txt then
    --        attr_txt = createRichLabel(24, cc.c4b(0xc1,0xb7,0xab,0xff), cc.p(0, 0.5), nil, nil, nil, 380)
    --        self.rouse_panel:addChild(attr_txt)
    --        self.tree_attr_list[i] = attr_txt
    --    end
    --    attr_txt:setVisible(true)
    --    local pos_x = 92 + (1-i%2)*312
    --    local pos_y = 188 - (math.ceil(i/2)-1)*46
    --    attr_txt:setPosition(cc.p(pos_x, pos_y))
    --    local attr_icon = PathTool.getAttrIconByStr(attr_key)
    --    attr_txt:setString(_string_format("<img src='%s' scale=1 /><div fontcolor=#643223>    %s</div>", PathTool.getResFrame("common", attr_icon), attr_val))
    --end
    --
    --self.tree_is_max_step = false
    --self.rouse_btn:setVisible(true)
    --if self.elfin_tree_data.lev >= Config.SpriteData.data_tree_up_lv_length then
    --    self.tree_is_max_step = true
    --    for i=1,2 do
    --        self:showTreeCostInfo(false, i)
    --    end
    --    self.max_lv_sp:setVisible(true)
    --    self.rouse_btn:setVisible(false)
    --    self.max_lv_sp:setPositionX(360)
    --else
    --    if self.elfin_tree_data.lev >= step_cfg.lev_max then -- 达到当前阶级最大等级，显示为唤醒
    --        self.rouse_btn_label:setString(TI18N("升星"))
    --        self.max_lv_sp:setVisible(true)
    --        self.rouse_cost_panel:setVisible(false)
    --        self.tree_step_max = true
    --        self.tree_is_max_step = false
    --        self.max_lv_sp:setPositionX(173)
    --    else -- 未达到当前阶级最大等级，显示为复苏
    --        self.max_lv_sp:setVisible(false)
    --        self.rouse_cost_panel:setVisible(true)
    --        self.rouse_btn_label:setString(TI18N("升级"))
    --        self.tree_step_max = false
    --        if level_cfg.expend then
    --            for i,v in ipairs(level_cfg.expend) do
    --                local item_bid = v[1]
    --                local item_num = v[2]
    --                if i == 1 then
    --                    self.cost_item_bid_1 = item_bid
    --                    self.cost_item_need_num_1 = item_num
    --                elseif i == 2 then
    --                    self.cost_item_bid_2 = item_bid
    --                    self.cost_item_need_num_2 = item_num
    --                end
    --                self:showTreeCostInfo(true, i, item_bid, item_num)
    --            end
    --        end
    --    end
    --end
end

-- 根据位置获取对应精灵的id
function ElfinRousePanel:getTreeElfinBidByPos( pos )
    if not self.elfin_tree_data or next(self.elfin_tree_data) == nil then return end

    local elfin_bid
    for k,v in pairs(self.elfin_tree_data.sprites) do
        if v.pos == pos then
            elfin_bid = v.item_bid
            break
        end
    end
    return elfin_bid
end

-- 显示消耗材料
function ElfinRousePanel:showTreeCostInfo( status, index, item_bid, need_num )
    --local object = self.cost_objects[index]
    local object = self.cost_item_list[index]
    if not object then return end

    if status == true then
        --object.cost_bg:setVisible(true)
        --object.res_icon:setVisible(true)
        --object.cost_txt:setVisible(true)

        local item_cfg = Config.ItemData.data_get_data(item_bid)
        if item_cfg then
            local item_res = PathTool.getItemRes(item_cfg.icon)
            loadSpriteTexture(object.icon, item_res, LOADTEXT_TYPE)
            local have_num = BackpackController:getInstance():getModel():getItemNumByBid(item_bid)
            object.num1:setString(string.format("/%s", MoneyTool.GetMoneyString(need_num, false)))
            object.num2:setString(string.format("%s", MoneyTool.GetMoneyString(have_num, false)))
            --object.cost_txt:setString(string.format("%s/%s", MoneyTool.GetMoneyString(have_num, false), MoneyTool.GetMoneyString(need_num, false)))
            if have_num < need_num then
                object.num2:setTextColor(cc.c3b(0xff,0x23,0x1e))
                --object.cost_txt:setTextColor(cc.c3b(255, 93, 93))
            else
                object.num2:setTextColor(cc.c3b(0x55,0xed,0x40))
                --object.cost_txt:setTextColor(cc.c3b(255, 246, 228))
            end
            local total_width = object.num1:getContentSize().width + object.num2:getContentSize().width
            local scale = 1
            if total_width > 180 then
                scale = 180/total_width
            end
            object.num2:setPositionX(object.num1:getPositionX() - scale * object.num1:getContentSize().width)
            object.num1:setScale(scale)
            object.num2:setScale(scale)
        else
            Debug.error("找不到道具配置！ID:"..item_bid)
        end

        object:setVisible(true)
    else
        object:setVisible(false)
        --object.cost_bg:setVisible(false)
        --object.res_icon:setVisible(false)
        --object.cost_txt:setVisible(false)
    end
end

-- 道具数量变化
function ElfinRousePanel:checkNeedUpdateItemNum( item_list )
    if item_list == nil or next(item_list) == nil then return end
    for k, v in pairs(item_list) do
        if v.config then
            if self.cost_item_bid_1 and v.config.id == self.cost_item_bid_1 then
                self:showTreeCostInfo(true, 1, self.cost_item_bid_1, self.cost_item_need_num_1)
            elseif self.cost_item_bid_2 and v.config.id == self.cost_item_bid_2 then
                self:showTreeCostInfo(true, 2, self.cost_item_bid_2, self.cost_item_need_num_2)
            end
        end
    end
end

-- 唤醒\复苏
function ElfinRousePanel:onClickRouseBtn(  )
    if not self.elfin_tree_data or next(self.elfin_tree_data) == nil then return end
    if self.tree_step_max == true then -- 唤醒(进阶)
        _controller:openElfinTreeStepWindow(true)
    else -- 复苏(升级)
        _controller:sender26511()
    end
end

-- 调整精灵顺序
function ElfinRousePanel:onClickAdjustBtn(  )
    _controller:openElfinAdjustWindow(true)
end

function ElfinRousePanel:startTimeTicket()
    if self.time_ticket == nil then
        self.can_play_lvup_sound = true
        self.time_idnex = 0
        local _callback = function()
            if self.tree_step_max == true then
                self:clearTimeTicket()
            else
                _controller:sender26511()
                self.can_play_lvup_sound = false
                self.time_idnex = self.time_idnex + 1
                if self.time_idnex > 2 then
                    self.time_idnex = 0
                    self.can_play_lvup_sound = true
                end
            end
        end
        self.time_ticket = GlobalTimeTicket:getInstance():add(_callback, 0.2)
    end
end

function ElfinRousePanel:clearTimeTicket()
    if self.sequence_action then
        self.rouse_btn:stopActionByTag(10086)
        self.sequence_action = nil
    end
    if self.time_ticket ~= nil then
        GlobalTimeTicket:getInstance():remove(self.time_ticket)
        self.time_ticket = nil
    end
end 

-- 唤醒规则
function ElfinRousePanel:onClickRouseRuleBtn( param, sender, event_type )
    local rule_cfg = Config.SpriteData.data_const["ancient_desc"]
    if rule_cfg then
        TipsManager:getInstance():showCommonTips(rule_cfg.desc, sender:getTouchBeganPosition(), nil, nil, 480)
    end
end

------------------@ 红点
function ElfinRousePanel:updateElfinRedInfo( bid, status )
    if not self.elfin_tree_data or next(self.elfin_tree_data) == nil then return end

    if bid == HeroConst.RedPointType.eElfin_tree_lvup then -- 古树升级、进阶红点
        self:updateTreeLvupRedStatus()
    elseif bid == HeroConst.RedPointType.eElfin_empty_pos then -- 古树有可放置的精灵
        self:updateTreeElfinRedStatus()
    elseif bid == HeroConst.RedPointType.eElfin_compound then -- 上阵精灵是否有可合成的精灵
        self:updateTreeElfinRedStatus()
    elseif bid == HeroConst.RedPointType.eElfin_higher_lv then -- 上阵精灵是否有更高阶的同类精灵
        self:updateTreeElfinRedStatus()
    else
        -- 古树升级、进阶红点
        self:updateTreeLvupRedStatus()
        -- 古树有可放置的精灵
        self:updateTreeElfinRedStatus()
    end
end


-- 古树升级、进阶红点
function ElfinRousePanel:updateTreeLvupRedStatus(  )
    local red_status = _model:getElfinRedStatusByRedBid(HeroConst.RedPointType.eElfin_tree_lvup)
    --addRedPointToNodeByStatus(self.rouse_btn, red_status, 10, 10)
    if red_status == true and self.rouse_btn_redpoint_spine == nil then
        self.rouse_btn_redpoint_spine = PathTool.gw_createRedpointSpine()
        self.rouse_btn_redpoint:addChild(self.rouse_btn_redpoint_spine)
    end
    self.rouse_btn_redpoint:setVisible(red_status)
end

-- 古树有可放置的精灵红点
function ElfinRousePanel:updateTreeElfinRedStatus(  )
    --if not self.tree_elfin_list then return end
    --for k,item in pairs(self.tree_elfin_list) do
    --    item:updateResStatus()
    --end
    if self.hole_item_list == nil then return end

    for k,item in pairs(self.hole_item_list) do
        local red_status = self:checkHoleItemRedpoint(k)
        if red_status == true and item.redpoint_spine == nil then
            item.redpoint_spine = PathTool.gw_createRedpointSpine()
            item.redpoint:addChild(item.redpoint_spine)
        end
        item.redpoint:setVisible(red_status)
    end
end
function ElfinRousePanel:checkHoleItemRedpoint(pos)
    local red_status = false

    local elfin_bid = self:getTreeElfinBidByPos(pos)
    if elfin_bid and elfin_bid == 0 and _model:getElfinRedStatusByRedBid(HeroConst.RedPointType.eElfin_empty_pos) then
        red_status = true
    elseif elfin_bid then
        local elfin_cfg = Config.SpriteData.data_elfin_data(elfin_bid)
        if elfin_cfg then
            -- 是否可以合成
            local elfin_com_cfg = Config.SpriteData.data_elfin_com[elfin_bid]
            if elfin_com_cfg and elfin_com_cfg.expend and next(elfin_com_cfg.expend) ~= nil then
                red_status = true
                for _,v in pairs(elfin_com_cfg.expend) do
                    local need_num = v[2]
                    local have_num = BackpackController:getInstance():getModel():getItemNumByBid(v[1])
                    if have_num < need_num then
                        red_status = false
                    end
                end
            end
            if red_status == false then
                -- 是否有更高阶的同类精灵
                local all_elfin_data = BackpackController:getInstance():getModel():getAllBackPackArray(BackPackConst.item_tab_type.ELFIN) or {}
                for k,v in pairs(all_elfin_data) do
                    local elfin_cfg = Config.SpriteData.data_elfin_data(v.base_id)
                    if elfin_cfg then
                        if elfin_cfg.sprite_type == elfin_cfg.sprite_type and elfin_cfg.step > elfin_cfg.step then
                            red_status = true
                            break
                        end
                    end
                end
            end
        end
    end

    return red_status
end


function ElfinRousePanel:DeleteMe(  )
    self:clearTimeTicket()

    if self.hole_item_list then
        for i,v in pairs(self.hole_item_list) do
            if v.spine then
                v.spine:setVisible(false)
                v.spine:removeFromParent()
                v.spine = nil
            end
            if v.redpoint_spine then
                v.redpoint_spine:setVisible(false)
                v.redpoint_spine:removeFromParent()
                v.redpoint_spine = nil
            end
        end

        self.hole_item_list = nil
    end

    if self.rouse_btn_redpoint_spine then
        self.rouse_btn_redpoint_spine:setVisible(false)
        self.rouse_btn_redpoint_spine:removeFromParent()
        self.rouse_btn_redpoint_spine = nil
    end

    --for k,item in pairs(self.tree_skill_list) do
    --    item:DeleteMe()
    --    item = nil
    --end
    --for k,item in pairs(self.tree_elfin_list) do
    --    item:DeleteMe()
    --    item = nil
    --end

	if self.init_res_load then
        self.init_res_load:DeleteMe()
        self.init_res_load = nil
    end
    if self.tree_bg_load then
        self.tree_bg_load:DeleteMe()
        self.tree_bg_load = nil
    end
 
    if self.fight_label then
        self.fight_label:DeleteMe()
    end
    self.fight_label = nil

    if self.get_tree_data_event then
        GlobalEvent:getInstance():UnBind(self.get_tree_data_event)
        self.get_tree_data_event = nil
    end
    if self.tree_up_lv_event then
        GlobalEvent:getInstance():UnBind(self.tree_up_lv_event)
        self.tree_up_lv_event = nil
    end
    
   
    if self.add_goods_event then
        GlobalEvent:getInstance():UnBind(self.add_goods_event)
        self.add_goods_event = nil
    end
    if self.del_goods_event then
        GlobalEvent:getInstance():UnBind(self.del_goods_event)
        self.del_goods_event = nil
    end
    if self.modify_goods_event then
        GlobalEvent:getInstance():UnBind(self.modify_goods_event)
        self.modify_goods_event = nil
    end
    if self.update_red_status_event then
        GlobalEvent:getInstance():UnBind(self.update_red_status_event)
        self.update_red_status_event = nil
    end
end

function ElfinRousePanel:onClickHoleItem(index)
    local elfin_bid = self:getTreeElfinBidByPos(index)
    if elfin_bid then
        local elfin_cfg = Config.SpriteData.data_elfin_data(elfin_bid)
        if elfin_bid == 0 or not elfin_cfg then -- 已解锁，但未放置精灵
            _controller:openElfinChooseWindow(true, {elfin_pos = index})
        else
            -- 当前位置没放精灵，或者精灵不可合灵（达到最大等级）时，直接打开精灵选择界面
            if elfin_bid == 0 or not Config.SpriteData.data_elfin_com[elfin_bid] then
                local setting = {}
                setting.elfin_pos = index
                if elfin_bid ~= 0 then
                    setting.elfin_bid = elfin_bid
                end
                _controller:openElfinChooseWindow(true, setting)

            else
                _controller:openElfinCompoundWindow(true, elfin_bid, index)
            end
        end
    else
        local need_step = Config.SpriteData.data_tree_limit[index]
        if need_step then
            message(StringFormat(UI_TI18N(70019), need_step))
        end
    end
end
function ElfinRousePanel:onClickSkillItem(index)
    local elfin_bid = self:getTreeElfinBidByPos(index)
    if elfin_bid then
        local elfin_cfg = Config.SpriteData.data_elfin_data(elfin_bid)
        if elfin_bid == 0 or not elfin_cfg then -- 已解锁，但未放置精灵
            _controller:openElfinChooseWindow(true, {elfin_pos = index})
        else
            local skill_cfg = Config.SkillData.data_get_skill(elfin_cfg.skill)
            if skill_cfg then
                TipsManager:getInstance():showSkillTips(skill_cfg, false, false, false)
            else
                Debug.error("找不到精灵技能配置！ID:"..elfin_cfg.skill)
            end
        end
    else
        local need_step = Config.SpriteData.data_tree_limit[index]
        if need_step then
            message(StringFormat(UI_TI18N(70019), need_step))
        end
    end
end