---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by gw.
--- DateTime: 2021/6/29 16:08
---
GW_ArenaWindow = GW_ArenaWindow or BaseClass(BaseView)

local box_config = Config.ArenaData.data_season_num_reward
local box_reward_length = Config.ArenaData.data_season_num_reward_length

local role_vo = RoleController:getInstance():getRoleVo()
local controller = ArenaController:getInstance()
local model = ArenaController:getInstance():getModel()
local game_net = GameNet:getInstance()
local string_format = string.format
local table_sort = table.sort
local table_insert = table.insert
local table_remove = table.remove

function GW_ArenaWindow:__init()
    self.ctrl = GW_ArenaController:getInstance()
    self.is_full_screen = true
    self.layout_name = "gw_arena/gw_arena_window"

    self.res_list = {
        { path = PathTool.getPlistImgForDownLoad("gw_arena", "gw_arena"), type = ResourcesType.plist},
        { path = PathTool.getPlistImgForDownLoad("gw_hero_bag","img_yingxiong", true), type = ResourcesType.single },
    }

    self.bool_box_status = {}

end

function GW_ArenaWindow:openRootWnd()
    ExchangeController:getInstance():send23606()
    self:updateTopNumWealth()

    self:handleEvent(true)
    self:updateMyStandings()
    controller:sender20208()
    controller:requestLoopChalllengeRank()
    StringUtil.gw_setRoleNickName(self.right_info_spine_info_nick_name, role_vo.name)
    --StringUtil.gw_setNickName(self.right_info_spine_info_nick_name, role_vo.name)
    self:updateSpineModel(role_vo.look_id)
    --self:handleEvent(true)

    local red_status = ArenaController:getInstance():getModel():getLoopMatchRedStatus(ArenaConst.red_type.loop_log)
    addRedPointSpineToNode(self.record_btn, red_status, -10, -10)
end

function GW_ArenaWindow:open_callback()
    self.left_top_container = self.root_wnd:getChildByName("left_top_container")
    self.left_top_container:setPositionX(display.getLeft())
    self.left_top_container:setPositionY(display.getTop())
    self.right_top_container = self.root_wnd:getChildByName("right_top_container")
    self.right_top_container:setPositionX(display.getRight())
    self.right_top_container:setPositionY(display.getTop())
    self.left_info = self.root_wnd:getChildByName("left_info")
    self.left_info:setPositionX(display.getLeft())
    self.left_info:setPositionY(display.getBottom())
    self.right_info = self.root_wnd:getChildByName("right_info")
    self.right_info:setPositionX(display.getRight())
    self.right_info:setPositionY(display.getBottom())

    --背景
    self.background = self.root_wnd:getChildByName("background")
    self.background:setScale(display.getMaxScale())
    local bg_res = PathTool.getPlistImgForDownLoad("gw_hero_bag", "img_yingxiong", true)
    if not self.background_load then
        self.background_load = loadImageTextureFromCDN(self.background, bg_res, ResourcesType.single, self.background_load)
    end

    --返回上一级
    self.back_btn = self.left_top_container:getChildByName("back_btn")
    self.back_btn:getChildByName("label"):setString(UI_TI18N(10000002))
    self.back_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            BattleController:getInstance():send20060(0)
            GW_ArenaHallController:getInstance():openView()
            self.ctrl:closeView()
        end
    end)
    --返回主城
    self.home_btn = self.right_top_container:getChildByName("home_btn")
    self.home_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            BackToHome()
        end
    end)

    --上方资产
    self.top_num_wealth_list = {}
    for i=1,3 do
        self.top_num_wealth_list[i] = {}
        if i==1 then
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("gold_info")
        elseif i==2 then
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("diamond_info")
        else
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("hero_exp_info")
        end
        self.top_num_wealth_list[i].icon = self.top_num_wealth_list[i].btn:getChildByName("icon")
        self.top_num_wealth_list[i].value = self.top_num_wealth_list[i].btn:getChildByName("label")
    end
    self.coin_redpoint = self.top_num_wealth_list[2].btn:getChildByName("add")

    --左边信息
    local left_info_bg = self.left_info:getChildByName("bg")
    left_info_bg:setContentSize(cc.size(526, display.height - 30))
    local left_info_title_bg = self.left_info:getChildByName("title_bg")
    left_info_title_bg:setPositionY(display.height - 110)
    local left_info_title = self.left_info:getChildByName("title")
    left_info_title:setPositionY(display.height - 115)
    left_info_title:setString(UI_TI18N(22018))
    local left_info_list_bg = self.left_info:getChildByName("list_bg")
    left_info_list_bg:setContentSize(cc.size(460, display.height - 186))
    self.left_info_list_container = self.left_info:getChildByName("list_container")
    self.left_info_list_container_size = cc.size(460, display.height - 186)
    self.left_info_list_container:setContentSize(self.left_info_list_container_size)
    self.left_info_list_container:setVisible(false)

    --右边信息
    self.right_info_box_reward = self.right_info:getChildByName("box_reward")
    self.right_info_box_reward:setPositionY(display.height)
    self.right_info_less_time_info = self.right_info_box_reward:getChildByName("less_time_info")
    self.right_info_less_time_info_bg = self.right_info_less_time_info:getChildByName("bg")
    self.right_info_less_time_info_bg = self.right_info_less_time_info:getChildByName("bg")
    self.right_info_less_time_info_label1 = self.right_info_less_time_info:getChildByName("label1")
    self.right_info_less_time_info_label1:setString(UI_TI18N(22019))
    self.right_info_less_time_info_label2 = self.right_info_less_time_info:getChildByName("label2")
    self.right_info_less_time_info_label2:setPositionX(self.right_info_less_time_info_label1:getPositionX() + self.right_info_less_time_info_label1:getContentSize().width)
    self.right_info_challenge_count = self.right_info_box_reward:getChildByName("challenge_count")
    self.right_info_challenge_count_label = self.right_info_box_reward:getChildByName("challenge_count_label")
    self.right_info_challenge_count_label:setString(UI_TI18N(22020))
    self.right_info_challenge_count_label:setFontSize(24)
    if self.right_info_challenge_count_label:getContentSize().width > 130 then
        for k=1,10 do
            self.right_info_challenge_count_label:setFontSize(24-k)
            if self.right_info_challenge_count_label:getContentSize().width <= 130 then
                break
            end
        end
    end
    self.right_info_bar = self.right_info_box_reward:getChildByName("bar")
    self.right_info_reward_start_node = self.right_info_box_reward:getChildByName("reward_start_node")
    self.right_info_reward_end_node = self.right_info_box_reward:getChildByName("reward_end_node")
    self.right_info_box_list = {}
    for i=1,8 do
        self.right_info_box_list[i] = self.right_info_box_reward:getChildByName("box_"..i)
        self.right_info_box_list[i].flag = self.right_info_box_list[i]:getChildByName("flag")
        self.right_info_box_list[i].count_info_num = self.right_info_box_list[i]:getChildByName("count_info"):getChildByName("num")
        self.right_info_box_list[i].item_info = self.right_info_box_list[i]:getChildByName("item_info")
        self.right_info_box_list[i].item_info:addTouchEventListener(function(sender, event_type)
            customClickAction_4(sender, event_type)
            if event_type == ccui.TouchEventType.ended then
                if self.bool_box_status ~= nil and self.bool_box_status[i] and self.bool_box_status[i] == 1 then
                    controller:requestGetChallengeTimesAwards(box_config[i].num)
                else
                    if self.right_info_box_list[i].item_id then
                        local config = Config.ItemData.data_get_data(self.right_info_box_list[i].item_id)
                        if config ~= nil then
                            local type = config.type
                            if BackPackConst.checkIsEquip(type) then
                                HeroController:getInstance():openEquipTips(true, config)
                            elseif BackPackConst.checkoutIsWeekCard(type) then
                                TipsManager:getInstance():showWeekCardTips(true,config)
                            elseif BackPackConst.checkIsHeroSkin(type) then
                                HeroController:getInstance():openHeroSkinTipsPanel(true, config)
                            elseif BackPackConst.checkIsElfin(type) then -- 精灵
                                TipsManager:getInstance():showElfinTips(self.right_info_box_list[i].item_id)
                            else
                                TipsManager:getInstance():showGoodsTips(config)
                            end
                        end
                    end
                end
            end
        end)
        self.right_info_box_list[i].item_info_bg = self.right_info_box_list[i].item_info:getChildByName("bg")
        self.right_info_box_list[i].item_info_icon = self.right_info_box_list[i].item_info:getChildByName("icon")
        self.right_info_box_list[i].item_info_canget_cover = self.right_info_box_list[i].item_info:getChildByName("canget_cover")
        self.right_info_box_list[i].item_info_getted_cover = self.right_info_box_list[i].item_info:getChildByName("getted_cover")
        self.right_info_box_list[i].item_info_num = self.right_info_box_list[i].item_info:getChildByName("num")
        self.right_info_box_list[i]:setVisible(false)
    end
    self.season_box_get_num = {}
    if box_reward_length > 8 then
        box_reward_length = 8
    end
    local box_ave_x = 614 / box_reward_length
    for i = 1, box_reward_length do
        self.right_info_box_list[i]:setPositionX(-670 + box_ave_x * i)
        self.right_info_box_list[i].count_info_num:setString(box_config[i].num)
        for k,v in pairs(box_config[i].items) do
            local config = Config.ItemData.data_get_data(v[1])
            if config ~= nil then
                self.right_info_box_list[i].item_info_icon:loadTexture(PathTool.getItemRes(config.icon), LOADTEXT_TYPE)
            else
                Debug.error("找不到道具配置！！ID:"..v[1])
            end
            self.right_info_box_list[i].item_info_num:setString(string.format("X%d", v[2]))
            self.right_info_box_list[i].item_id = v[1]
            self.right_info_box_list[i].item_num = v[2]
            break
        end

        self.season_box_get_num[i] = box_config[i].num

        self.right_info_box_list[i]:setVisible(true)
    end

    self.right_info_my_standing_info = self.right_info:getChildByName("my_standing_info")
    self.right_info_my_standing_info_title = self.right_info_my_standing_info:getChildByName("title")
    self.right_info_my_standing_info_title:setString(UI_TI18N(22021))
    self.right_info_my_standing_info_rank_num = self.right_info_my_standing_info:getChildByName("rank_num")
    self.right_info_my_standing_info_score = self.right_info_my_standing_info:getChildByName("score")
    local win_lose_record_bg = self.right_info_my_standing_info:getChildByName("win_lose_record_bg")
    self.right_info_my_standing_info_win_num = win_lose_record_bg:getChildByName("win_num")
    self.right_info_my_standing_info_lose_num = win_lose_record_bg:getChildByName("lose_num")
    self.right_info_my_standing_info_daily_reward_title = self.right_info_my_standing_info:getChildByName("daily_reward_title")
    self.right_info_my_standing_info_daily_reward_title:setString(UI_TI18N(22022))
    local daily_reward_node = self.right_info_my_standing_info:getChildByName("daily_reward_node")
    self.right_info_daily_reward_list = {}
    for i=1,2 do
        self.right_info_daily_reward_list[i] = GW_GoodsItem1.new(false, true, false, 0.75)
        self.right_info_daily_reward_list[i]:setDefaultTip()
        daily_reward_node:addChild(self.right_info_daily_reward_list[i])
        self.right_info_daily_reward_list[i]:setPosition(120 * (i-1), 0)
    end

    self.right_info_spine_info = self.right_info:getChildByName("spine_info")
    self.right_info_spine_info_spine_node = self.right_info_spine_info:getChildByName("spine_node")
    self.right_info_spine_info_nick_name = self.right_info_spine_info:getChildByName("nick_name")
    --商店
    self.shop_btn = self.right_info:getChildByName("shop_btn")
    self.shop_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            self:onClickShopBtn()
        end
    end)
    --奖励
    self.reward_btn = self.right_info:getChildByName("reward_btn")
    self.reward_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            self:onClickRewardBtn()
        end
    end)
    --记录
    self.record_btn = self.right_info:getChildByName("record_btn")
    self.record_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            self:onClickRecordBtn()
        end
    end)
    --防守布阵
    self.formation_btn = self.right_info:getChildByName("formation_btn")
    self.formation_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            self:onClickFormationBtn()
        end
    end)
    self.formation_btn_label = self.formation_btn:getChildByName("label")
    self.formation_btn_label:setString(UI_TI18N(22023))
    --开始挑战
    self.challenge_btn = self.right_info:getChildByName("challenge_btn")
    self.challenge_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            self:onClickChallengeBtn()
        end
    end)
    self.challenge_btn_label = self.challenge_btn:getChildByName("label")
    self.challenge_btn_label:setString(UI_TI18N(22024))
    self.free_count_tips = createRichLabel(20, cc.c4b(0xff,0xff,0xff,0xff), cc.p(0.5, 0.5), cc.p(-149, 97), nil, nil, 300)
    self.right_info:addChild(self.free_count_tips)

    --self.left_top_container = self.root_wnd:getChildByName("left_top_container")
    --self.right_top_container = self.root_wnd:getChildByName("right_top_container")
    --self.right_botton_container = self.root_wnd:getChildByName("right_botton_container")
    --self.left_botton_container = self.root_wnd:getChildByName("left_botton_container")
    --self.center_center_container = self.root_wnd:getChildByName("center_center_container")
    --
    ----返回上一级
    --self.back_btn = self.left_top_container:getChildByName("back_btn")
    --self.back_btn:addTouchEventListener(function(sender, event_type)
    --    if event_type == ccui.TouchEventType.ended then
    --        playButtonSound2()
    --        self.ctrl:closeView()
    --    end
    --end)
    ----返回主城
    --self.home_btn = self.right_top_container:getChildByName("home_btn")
    --self.home_btn:addTouchEventListener(function(sender, event_type)
    --    if event_type == ccui.TouchEventType.ended then
    --        BackToHome()
    --    end
    --end)
    --
    ----金币信息
    --self.right_top_container_gold_info = self.right_top_container:getChildByName("gold_info")
    --self.right_top_container_gold_info_value = self.right_top_container_gold_info:getChildByName("value")
    --self.right_top_container_gold_info_redpoint = self.right_top_container_gold_info:getChildByName("add")
    --self.right_top_container_gold_info:addTouchEventListener(function(sender, event_type)
    --    if event_type == ccui.TouchEventType.ended then
    --        playButtonSound2()
    --        ExchangeController:getInstance():openExchangeMainView(true)
    --    end
    --end)
    ----钻石信息
    --self.right_top_container_diamond_info = self.right_top_container:getChildByName("diamond_info")
    --self.right_top_container_diamond_info_value = self.right_top_container_diamond_info:getChildByName("value")
    --self.right_top_container_diamond_info:addTouchEventListener(function(sender, event_type)
    --    if event_type == ccui.TouchEventType.ended then
    --        playButtonSound2()
    --        VipController:getInstance():openVipMainWindow(true, VIPTABCONST.CHARGE)
    --    end
    --end)

    ----宝箱奖励信息
    --local box_reward = self.right_top_container:getChildByName("box_reward")
    --self.box_reward_less_time_label = box_reward:getChildByName("less_time"):getChildByName("label")
    --self.box_reward_challenge_count = box_reward:getChildByName("challenge_count")
    --self.box_reward_bar = box_reward:getChildByName("bar")
    --self.box_reward_reward_start_node = box_reward:getChildByName("reward_start_node")
    --self.box_reward_reward_end_node = box_reward:getChildByName("reward_end_node")
    ----赛季宝箱奖励
    --self.season_box_reward = {}
    --for i = 1, 8 do
    --    self.season_box_reward[i] = {}
    --    self.season_box_reward[i].root_wnd = box_reward:getChildByName("box_"..i)
    --    self.season_box_reward[i].empty_flag = self.season_box_reward[i].root_wnd:getChildByName("empty_flag")
    --    self.season_box_reward[i].active_flag = self.season_box_reward[i].root_wnd:getChildByName("active_flag")
    --    self.season_box_reward[i].empty_num = self.season_box_reward[i].root_wnd:getChildByName("empty_num")
    --    self.season_box_reward[i].active_num = self.season_box_reward[i].root_wnd:getChildByName("active_num")
    --    self.season_box_reward[i].item_node = self.season_box_reward[i].root_wnd:getChildByName("item_node")
    --    self.season_box_reward[i].item = GW_BackPackItem1.new(nil,true,nil,0.42)
    --    self.season_box_reward[i].item_node:addChild(self.season_box_reward[i].item)
    --    self.season_box_reward[i].item:setDefaultTip(false)
    --    self.season_box_reward[i].item:setPosition(cc.p(0,0))
    --    self.season_box_reward[i].item:addCallBack(function ()
    --        if self.bool_box_status ~= nil and self.bool_box_status[i] and self.bool_box_status[i] == 1 then
    --            controller:requestGetChallengeTimesAwards(box_config[i].num)
    --        else
    --            if self.season_box_reward[i].item_id then
    --                local config = Config.ItemData.data_get_data(self.season_box_reward[i].item_id)
    --                if config ~= nil then
    --                    local type = config.type
    --                    if BackPackConst.checkIsEquip(type) then
    --                        HeroController:getInstance():openEquipTips(true, config)
    --                    elseif BackPackConst.checkoutIsWeekCard(type) then
    --                        TipsManager:getInstance():showWeekCardTips(true,config)
    --                    elseif BackPackConst.checkIsHeroSkin(type) then
    --                        HeroController:getInstance():openHeroSkinTipsPanel(true, config)
    --                    elseif BackPackConst.checkIsElfin(type) then -- 精灵
    --                        TipsManager:getInstance():showElfinTips(self.season_box_reward[i].item_id)
    --                    else
    --                        TipsManager:getInstance():showGoodsTips(config)
    --                    end
    --                end
    --            end
    --        end
    --    end)
    --    self.season_box_reward[i].getted_flag = self.season_box_reward[i].root_wnd:getChildByName("getted_flag")
    --    self.season_box_reward[i].root_wnd:setVisible(false)
    --end
    --self.season_box_get_num = {}
    --if box_reward_length > 8 then
    --    box_reward_length = 8
    --end
    --local box_ave_x = 748 / box_reward_length
    --for i = 1, box_reward_length do
    --    self.season_box_reward[i].root_wnd:setPositionX(100 + box_ave_x * i)
    --    self.season_box_reward[i].empty_num:setString(box_config[i].num)
    --    self.season_box_reward[i].active_num:setString(box_config[i].num)
    --    for k,v in pairs(box_config[i].items) do
    --        self.season_box_reward[i].item:setBaseData(v[1], v[2])
    --        self.season_box_reward[i].item_id = v[1]
    --        self.season_box_reward[i].item_num = v[2]
    --        break
    --    end
    --    self.season_box_get_num[i] = box_config[i].num
    --
    --    self.season_box_reward[i].root_wnd:setVisible(true)
    --end
    --
    ----我的战绩
    --local my_standings = self.right_botton_container:getChildByName("my_standings")
    --self.my_standings_rank_num = my_standings:getChildByName("rank_num")
    --self.my_standings_score_num = my_standings:getChildByName("score_num")
    --self.my_standings_win_num = my_standings:getChildByName("win_lose_record_bg"):getChildByName("win_num")
    --self.my_standings_lose_num = my_standings:getChildByName("win_lose_record_bg"):getChildByName("lose_num")
    --
    ----每日奖励
    --local day_reweard_bg = self.right_botton_container:getChildByName("day_reweard_bg")
    --self.day_reward_item_list = {}
    --for i=1,3 do
    --    local reward1_node = day_reweard_bg:getChildByName(string_format("reward%d_node", i))
    --    self.day_reward_item_list[i] = GW_BackPackItem1.new(nil,true,nil,0.55)
    --    reward1_node:addChild(self.day_reward_item_list[i])
    --    self.day_reward_item_list[i]:setDefaultTip()
    --    self.day_reward_item_list[i]:setPosition(cc.p(0,0))
    --    self.day_reward_item_list[i]:setVisible(false)
    --end
    --
    --
    ----免费挑战次数
    --self.free_challenge_count = self.right_botton_container:getChildByName("free_challenge_count")
    --
    ----展示角色模型节点
    --self.spine_node = self.center_center_container:getChildByName("spine_node")
    --
    ----商店
    --self.shop_btn = self.left_botton_container:getChildByName("shop_btn")
    ----奖励
    --self.reward_btn = self.left_botton_container:getChildByName("reward_btn")
    ----记录
    --self.record_btn = self.left_botton_container:getChildByName("record_btn")
    ----防守布阵
    --self.formation_btn = self.right_botton_container:getChildByName("formation_btn")
    ----开始挑战
    --self.challenge_btn = self.right_botton_container:getChildByName("challenge_btn")
    --
    ----排行榜
    --self.scroll_container = self.left_botton_container:getChildByName("rank_container")
    --local size = self.scroll_container:getContentSize()
    --local setting = {
    --    item_class = GW_ArenaLoopRankItem,
    --    start_x = 4,
    --    space_x = 4,
    --    start_y = 20,
    --    space_y = 4,
    --    item_width = 316,
    --    item_height = 110,
    --    row = 0,
    --    col = 1,
    --    need_dynamic = true
    --}
    --self.scroll_view = CommonScrollViewLayout.new(self.scroll_container, cc.p(0, 10), nil, nil, cc.size(size.width, size.height-20), setting)
    --
    ----我的排行榜信息
    --self.my_rank_info = self.left_botton_container:getChildByName("my_rank_info_bg")
    --self.my_rank_info_rank_num = self.my_rank_info:getChildByName("rank_num_bg"):getChildByName("rank_num")
    --self.my_rank_info_score_num = self.my_rank_info:getChildByName("score_node"):getChildByName("num")
    --self.my_rank_info_battle_num = self.my_rank_info:getChildByName("battle_node"):getChildByName("num")
    --self.my_rank_info_head_node = self.my_rank_info:getChildByName("head_node")
    --self.my_rank_info_role_head = PlayerHead.new(PlayerHead.type.square)
    --self.my_rank_info_role_head:setHeadLayerScale(0.6)
    --self.my_rank_info_role_head:setPosition(0, 0)
    --self.my_rank_info_head_node:addChild(self.my_rank_info_role_head)
    --self.my_rank_info_name = self.my_rank_info:getChildByName("name")
    --self.my_rank_info_lev = self.my_rank_info:getChildByName("lv_bg"):getChildByName("lv")
    --
    ----播放窗口动画
    --self:playEnterAnimatianByObj(self.root_wnd , 1)
end

function GW_ArenaWindow:register_event()
    if role_vo then
        if self.role_update_event == nil then
            self.role_update_event = role_vo:Bind(RoleEvent.UPDATE_ROLE_ATTRIBUTE, function(key, value)
                if key == "coin" or key == "gold" or key == "red_gold" or key == "silver_coin" or key == "hero_exp" then
                    self:updateTopNumWealth()
                elseif key == "lev" then 	--等级
                    self:updataExchangeRedPoint()
                end
            end)
        end
    end
    self.top_num_wealth_list[1].btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            VipController:getInstance():openVipMainWindow(true, VIPTABCONST.CHARGE)
        end
    end)
    self.top_num_wealth_list[2].btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            ExchangeController:getInstance():openExchangeMainView(true)
        end
    end)
    self.top_num_wealth_list[3].btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            local id = Config.ArenaData.data_const.arena_ticketcost.val[1][1]
            local config = Config.ItemData.data_get_data(id)
            if config then
                BackpackController:getInstance():openTipsSource(true, config)
            end
        end
    end)

    if self.update_rank_event == nil then
        self.update_rank_event = GlobalEvent:getInstance():Bind(ArenaEvent.UpdateLoopChallengeRank, function(data)
            self:updateRankList(data)
        end)
    end

    --registerButtonEventListener(self.shop_btn, handler(self, self.onClickShopBtn) ,false, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    --registerButtonEventListener(self.reward_btn, handler(self, self.onClickRewardBtn) ,false, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    --registerButtonEventListener(self.record_btn, handler(self, self.onClickRecordBtn) ,false, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    --registerButtonEventListener(self.formation_btn, handler(self, self.onClickFormationBtn) ,false, REGISTER_BUTTON_SOUND_CLOSED_TYPY)
    --registerButtonEventListener(self.challenge_btn, handler(self, self.onClickChallengeBtn) ,false, REGISTER_BUTTON_SOUND_CLOSED_TYPY)


    if self.update_challenge_time_num == nil then
        self.update_challenge_time_num = GlobalEvent:getInstance():Bind(ArenaEvent.UpdateLoopChallengeTimesList, function(data)
            if not data then return end
            self.cur_combat_num = data.had_combat_num
            if self.right_info_challenge_count then
                self.right_info_challenge_count:setString(string.format(UI_TI18N(22025), self.cur_combat_num))
            end
            self:updateMyStandings()

            self.right_info_bar:setPercent(self:segmentBarPercent(self.cur_combat_num))

            self.had_combat_num = data.had_combat_num
            for i,v in pairs(box_config) do
                self.bool_box_status[i] = 0
                if v.num <= data.had_combat_num then
                    self.bool_box_status[i] = 1
                    for k,val in pairs(data.num_list) do
                        if val.num == v.num then
                            self.bool_box_status[i] = 2
                        end
                    end
                end
                local status = 0--不可领取
                if v.num <= data.had_combat_num then
                    status = 1--可领取
                    for k,val in pairs(data.num_list) do
                        if val.num == v.num then
                            status = 2--已领取
                        end
                    end
                end

                if i <= #self.right_info_box_list then
                    local flag_res = PathTool.getResFrame("gw_arena", "Round4")
                    local item_bg_res = PathTool.getResFrame("gw_arena", "Round3")
                    if status == 0 then--不可领取
                        self.right_info_box_list[i].item_info_canget_cover:setVisible(false)
                        self.right_info_box_list[i].item_info_getted_cover:setVisible(false)
                        flag_res = PathTool.getResFrame("gw_arena", "Round5")
                    elseif status == 1 then--可领取
                        self.right_info_box_list[i].item_info_canget_cover:setVisible(true)
                        self.right_info_box_list[i].item_info_getted_cover:setVisible(false)
                        item_bg_res = PathTool.getResFrame("gw_arena", "Round2")
                    elseif status == 2 then--已领取
                        self.right_info_box_list[i].item_info_canget_cover:setVisible(false)
                        self.right_info_box_list[i].item_info_getted_cover:setVisible(true)
                        item_bg_res = PathTool.getResFrame("gw_arena", "Round1")
                    end

                    loadSpriteTexture(self.right_info_box_list[i].flag, flag_res, LOADTEXT_TYPE_PLIST)
                    self.right_info_box_list[i].item_info_bg:loadTexture(item_bg_res, LOADTEXT_TYPE_PLIST)
                end

                --if status == 0 then
                --    self.season_box_reward[i].empty_flag:setVisible(true)
                --    self.season_box_reward[i].empty_num:setVisible(true)
                --    self.season_box_reward[i].active_flag:setVisible(false)
                --    self.season_box_reward[i].active_num:setVisible(false)
                --else
                --    self.season_box_reward[i].empty_flag:setVisible(false)
                --    self.season_box_reward[i].empty_num:setVisible(false)
                --    self.season_box_reward[i].active_flag:setVisible(true)
                --    self.season_box_reward[i].active_num:setVisible(true)
                --end
                --
                --if status == 2 then
                --    self.season_box_reward[i].getted_flag:setVisible(true)
                --else
                --    self.season_box_reward[i].getted_flag:setVisible(false)
                --end
            end
        end)
    end

    -- 初始化或者断线重连的时候会跑出这个更新事件的
    self:addGlobalEvent(BackpackEvent.GET_ALL_DATA, function(bag_code)
        self:updateTopNumWealth()
    end)
    -- 增加物品的更新,这里需要判断增加的物品是不是当前标签页类型的,否则不刷新了
    self:addGlobalEvent(BackpackEvent.ADD_GOODS, function(bag_code, add_list)
        self:updateTopNumWealth()
    end)
    -- 删除一个物品更新,也需要判断当前标签页类型
    self:addGlobalEvent(BackpackEvent.DELETE_GOODS, function(bag_code,del_list)
        self:updateTopNumWealth()
    end)

    self:addGlobalEvent(BackpackEvent.MODIFY_GOODS_NUM, function(bag_code,change_list)
        self:updateTopNumWealth()
    end)

    --点金红点
    if self.coin_touch_redpoint == nil then
        self.coin_touch_redpoint = GlobalEvent:getInstance():Bind(ExchangeEvent.Extra_Reward, function(data)
            self.exchange_data = data
            self:updataExchangeRedPoint()
        end)
    end


    if self.update_arena_red_event == nil then
        self.update_arena_red_event = GlobalEvent:getInstance():Bind(ArenaEvent.UpdateArenaRedStatus, function(type, status)
            local red_status = ArenaController:getInstance():getModel():getLoopMatchRedStatus(ArenaConst.red_type.loop_log)
            addRedPointSpineToNode(self.record_btn, red_status, -10, -10)
        end)
    end
end

function GW_ArenaWindow:close_callback()
    doStopAllActions(self.background)

    self:handleEvent(false)

    if self.role_update_event ~= nil then
        role_vo:UnBind(self.role_update_event)
        self.role_update_event = nil
    end
    self.top_num_wealth_list = nil

    if self.right_info_daily_reward_list ~= nil then
        for i,v in pairs(self.right_info_daily_reward_list) do
            v:DeleteMe()
        end
        self.right_info_daily_reward_list = nil
    end

    if self.update_challenge_time_num ~= nil then
        GlobalEvent:getInstance():UnBind(self.update_challenge_time_num)
        self.update_challenge_time_num = nil
    end

    if self.partner_model ~= nil then
        self.partner_model:clearTracks()
        self.partner_model:removeFromParent()
        self.partner_model = nil
    end

    if self.update_rank_event ~= nil then
        GlobalEvent:getInstance():UnBind(self.update_rank_event)
        self.update_rank_event = nil
    end

    self.exchange_data = nil
    if self.coin_redpoint_spine ~= nil then
        self.coin_redpoint_spine:clearTracks()
        self.coin_redpoint_spine:removeFromParent()
        self.coin_redpoint_spine = nil
    end
    if self.coin_touch_redpoint then
        GlobalEvent:getInstance():UnBind(self.coin_touch_redpoint)
        self.coin_touch_redpoint = nil
    end

    if self.update_arena_red_event ~= nil then
        GlobalEvent:getInstance():UnBind(self.update_arena_red_event)
        self.update_arena_red_event = nil
    end

    if self.record_btn.wy_tips_spine ~= nil then
        self.record_btn.wy_tips_spine:clearTracks()
        self.record_btn.wy_tips_spine:removeFromParent()
        self.record_btn.wy_tips_spine = nil
    end

    self.ctrl:closeView()
end
--==============================--
--desc:移除ui这个操作只有在切换账号的时候触发
--time:2021-06-29 10:51:38
--@return
--==============================--
function GW_ArenaWindow:__delete()
    Debug.log("GW_ArenaWindow:__delete()")
end
--商店
function GW_ArenaWindow:onClickShopBtn(force)
    MallController:getInstance():openMallPanel(true, MallConst.MallType.ArenaShop)
end
--奖励
function GW_ArenaWindow:onClickRewardBtn(force)
    GW_ArenaRankRewardController:getInstance():openView()
end
--记录
function GW_ArenaWindow:onClickRecordBtn(force)
    --controller:openArenaLoopMyLogWindow(true)
    controller:openArenaLoopMyLogWindow(true)
    addRedPointSpineToNode(self.record_btn, false, 0, 0)
    model:updateArenaLoopLogStatus(FALSE)
end
--防守布阵
function GW_ArenaWindow:onClickFormationBtn(force)
    GW_EmbattleController:getInstance():openEmbattleView(PartnerConst.Fun_Form.Arena, {}, HeroConst.FormShowType.eFormSave)
end
--开始挑战
function GW_ArenaWindow:onClickChallengeBtn(force)
    GW_ArenaChallengeListController:getInstance():openView()
end

--刷新上方货币
function GW_ArenaWindow:updateTopNumWealth()
    if not self.top_num_wealth_list then return end

    if self.top_num_wealth_list[1] ~= nil then
        local key = "gold"
        local key_value = role_vo[key] or 0
        self.top_num_wealth_list[1].value:setString(MoneyTool.GetMoneyString(key_value))
        local item_id = Config.ItemData.data_assets_label2id[key]
        local config = Config.ItemData.data_get_data(item_id)
        if config then
            local res = PathTool.getItemRes(config.icon, false)
            loadSpriteTexture(self.top_num_wealth_list[1].icon, res, LOADTEXT_TYPE)
        end
        self.top_num_wealth_list[1].btn:setVisible(true)
    end
    if self.top_num_wealth_list[2] ~= nil then
        local key = "coin"
        local key_value = role_vo[key] or 0
        self.top_num_wealth_list[2].value:setString(MoneyTool.GetMoneyString(key_value))
        local item_id = Config.ItemData.data_assets_label2id[key]
        local config = Config.ItemData.data_get_data(item_id)
        if config then
            local res = PathTool.getItemRes(config.icon, false)
            loadSpriteTexture(self.top_num_wealth_list[2].icon, res, LOADTEXT_TYPE)
        end
        self.top_num_wealth_list[2].btn:setVisible(true)
    end
    if self.top_num_wealth_list[3] ~= nil then
        local id = Config.ArenaData.data_const.arena_ticketcost.val[1][1]
        local count = BackpackController:getInstance():getModel():getItemNumByBid(id)
        self.top_num_wealth_list[3].value:setString(MoneyTool.GetMoneyString(count))

        --local key = "hero_exp"
        --local key_value = role_vo[key] or 0
        --self.top_num_wealth_list[3].value:setString(MoneyTool.GetMoneyString(key_value))
        --local item_id = Config.ItemData.data_assets_label2id[key]
        local config = Config.ItemData.data_get_data(id)
        if config then
            local res = PathTool.getItemRes(config.icon, false)
            loadSpriteTexture(self.top_num_wealth_list[3].icon, res, LOADTEXT_TYPE)
        end
        self.top_num_wealth_list[3].btn:setVisible(true)
    end
end

function GW_ArenaWindow:handleEvent(status)
    if status == true then
        if self.time_ticket == nil then
            self.time_ticket = GlobalTimeTicket:getInstance():add(function()
                self:countDownTimeTicket()
            end, 1)
        end
        self:countDownTimeTicket()
    else
        if self.time_ticket ~= nil then
            GlobalTimeTicket:getInstance():remove(self.time_ticket)
            self.time_ticket = nil
        end
    end
end

function GW_ArenaWindow:countDownTimeTicket()
    local data = model:getMyLoopData()
    if data == nil then
        self:handleEvent(false)
        return
    end

    local less_time = data.end_time - game_net:getTime()
    if less_time >= 0 then
        self.right_info_less_time_info_label2:setString(string_format("%s", TimeTool.GetTimeFormat(less_time)))
        self.right_info_less_time_info_bg:setContentSize(cc.size(self.right_info_less_time_info_label1:getContentSize().width + self.right_info_less_time_info_label2:getContentSize().width + 36, 42))
    end
end

function GW_ArenaWindow:updateMyStandings()
    local my_data = model:getMyLoopData()
    if my_data == nil then
        self.right_info_my_standing_info:setVisible(false)
        self.free_count_tips:setString(string.format(UI_TI18N(22026), 0))
        return
    end

    self.right_info_my_standing_info_rank_num:setString(string.format(UI_TI18N(22027), my_data.rank))
    self.right_info_my_standing_info_score:setString(my_data.score)
    --self.my_standings_score_num:setString(my_data.score)
    --self.my_standings_rank_num:setString(my_data.rank)

    local win_count = 0
    local lose_count = 0
    if my_data.win_num then
        win_count = my_data.win_num
        if self.cur_combat_num then
            lose_count = self.cur_combat_num - my_data.win_num
            if lose_count < 0 then
                lose_count = 0
            end
        end
    end
    self.right_info_my_standing_info_win_num:setString(string.format(UI_TI18N(22028), win_count))
    self.right_info_my_standing_info_lose_num:setString(string.format(UI_TI18N(22029), lose_count))
    self.free_count_tips:setString(string.format(UI_TI18N(22026), my_data.can_combat_num))
    for i,v in pairs(self.right_info_daily_reward_list) do
        v:setVisible(false)
    end
    if my_data.rank > 0 then
        local config = nil
        for i, v in ipairs(Config.ArenaData.data_activity) do
            if v.min <= my_data.rank and v.max >= my_data.rank then
                config = v
                break
            end
        end
        if config and config.items ~= nil and next(config.items) ~= nil then
            for i, v in ipairs(config.items) do
                if i > #self.right_info_daily_reward_list then
                    break
                end

                self.right_info_daily_reward_list[i]:setBaseData(v[1], v[2])
                self.right_info_daily_reward_list[i]:setVisible(true)
            end
        end
    end

    --self.my_standings_win_num:setString(win_count)
    --self.my_standings_lose_num:setString(lose_count)
    --self.free_challenge_count:setString(my_data.can_combat_num)
    --
    --
    --for i=1,3 do
    --    self.day_reward_item_list[i]:setVisible(false)
    --end
    --if my_data.rank > 0 then
    --    local config = nil
    --    for i, v in ipairs(Config.ArenaData.data_activity) do
    --        if v.min <= my_data.rank and v.max >= my_data.rank then
    --            config = v
    --            break
    --        end
    --    end
    --    if config and config.items ~= nil and next(config.items) ~= nil then
    --        local index = 1
    --        for i, v in ipairs(config.items) do
    --            self.day_reward_item_list[index]:setBaseData(v[1], v[2])
    --            self.day_reward_item_list[index]:setVisible(true)
    --
    --            index = index + 1
    --            if index > 3 then
    --                break
    --            end
    --        end
    --    end
    --end


    self.right_info_my_standing_info:setVisible(true)
end

function GW_ArenaWindow:updateSpineModel(look_id)
    local data = RoleController:getInstance():getModel():gw_getRoleHeroDrawData()
    if data == nil or data.id == nil then
        self.right_info_spine_info:setVisible(false)
        return
    end

    local config = Config.PartnerData.data_partner_base[data.id]
    if config == nil then
        self.right_info_spine_info:setVisible(false)
        Debug.error("找不到英雄配置！！ID:"..data.id)
        return
    end

    local spine_res = config.spine_res

    if self.partner_model == nil then
        self.partner_model_res_id = spine_res
        self.partner_model = gw_createEffectSpine(spine_res, cc.p(0, 0), cc.p(0.5, 0.5), true, PlayerAction.gw_idle)
        self.right_info_spine_info_spine_node:addChild(self.partner_model)
        local spine_scale = 1
        local offset_x = 0
        local offset_y = 0
        local spine_scale_config = Config.PartnerData.data_model_scale_offset_fun(data.id)
        if spine_scale_config then
            spine_scale = spine_scale_config.arena_scale/1000
            offset_x = spine_scale_config.arena_coordinate[1]
            offset_y = spine_scale_config.arena_coordinate[2]
        end
        self.partner_model:setPosition(cc.p(0+offset_x,0+offset_y))
        self.partner_model:setScale(spine_scale)
    end
    self.right_info_spine_info:setVisible(true)

    if self.partner_model_res_id ~= spine_res then
        if self.partner_model ~= nil then
            self.partner_model:clearTracks()
            self.partner_model:removeFromParent()
            self.partner_model = nil
        end

        self:updateSpineModel(look_id)
    end
end

--分段处理进度条
function GW_ArenaWindow:segmentBarPercent(num)
    if num <= box_config[1].num then
        return (100 * num * (670+self.right_info_box_list[1]:getPositionX()))/(614 * box_config[1].num)
    end

    for i,v in pairs(box_config) do
        if i >= #box_config then
            break
        end

        if num > box_config[i].num and num <= box_config[i+1].num then
            local font_percent = 100 * (670+self.right_info_box_list[i]:getPositionX())/614
            local next_percent = 100 * (670+self.right_info_box_list[i+1]:getPositionX())/614
            local dis_percent = next_percent - font_percent
            local percent = font_percent + dis_percent * (num - box_config[i].num)/(box_config[i+1].num - box_config[i].num)
            return percent
        end
    end

    local font_percent = 100 * (670+self.right_info_box_list[#box_config - 1]:getPositionX())/614
    local next_percent = 100 * (670+self.right_info_box_list[#box_config]:getPositionX())/614
    local dis_percent = next_percent - font_percent
    local percent = font_percent + dis_percent * (num - box_config[#box_config - 1].num)/(box_config[#box_config].num - box_config[#box_config - 1].num)
    return percent
end

--刷新排行榜
function GW_ArenaWindow:updateRankList(data)
    local role_vo = RoleController:getInstance():getRoleVo()
    if data and role_vo then
        --self.my_rank_info_rank_num:setString(data.rank)
        --self.my_rank_info_role_head:setHeadRes(role_vo.face_id, false, LOADTEXT_TYPE)
        ----self.my_rank_info_role_head:setLev(nil)
        ----local avatar_bid = role_vo.avatar_base_id
        ----local vo = Config.AvatarData.data_avatar[avatar_bid]
        ----if vo then
        ----    local res_id = vo.res_id or 1
        ----    local res = PathTool.getTargetRes("headcircle", "txt_cn_headcircle_" .. res_id, false, false)
        ----    self.my_rank_info_role_head:showBg(res, cc.size(150,150), false, vo.offy)
        ----end
        --self.my_rank_info_name:setString(role_vo.name)
        --self.my_rank_info_lev:setString(string_format("Lv.%d", role_vo.lev))
        --self.my_rank_info_score_num:setString(data.score)
        --self.my_rank_info_battle_num:setString(role_vo.power)

        --self.role_name:setString(role_vo.name)
        --self.role_power:setString(role_vo.power)
        --local width = self.role_power:getContentSize().width + 75
        --local height = self.power_bg:getContentSize().height
        --self.power_bg:setContentSize(cc.size(width,height))
        --self.wish_num:setString(data.worship)
        --
        --if data.rank and data.rank <= 3 then
        --    if self.rank_num ~= nil then
        --        self.rank_num:setVisible(false)
        --    end
        --    if data.rank == 0 then
        --        self.rank_img:setVisible(false)
        --    else
        --        local res_id = PathTool.getResFrame("common", string.format("common_200%s", data.rank))
        --        if self.rank_res_id ~= res_id then
        --            self.rank_res_id  = res_id
        --            loadSpriteTexture(self.rank_img, res_id, LOADTEXT_TYPE_PLIST)
        --        end
        --        self.rank_img:setVisible(true)
        --    end
        --else
        --    if self.rank_num == nil then
        --        self.rank_num = CommonNum.new(1, self.my_container, 1, -2, cc.p(0.5, 0.5))
        --        self.rank_num:setPosition(59,77)
        --    end
        --    self.rank_num:setVisible(true)
        --    self.rank_num:setNum(data.rank)
        --    self.rank_img:setVisible(false)
        --end
        --
        --local config = model:getZoneConfig()
        --if config ~= nil then
        --    local msg = string.format(TI18N("段位积分:<div fontcolor=#249003 fontsize=22>%s</div>"),data.score or 0)
        --    self.my_score_info:setString(msg)
        --end
        --self.role_head:setHeadRes(role_vo.face_id, false, LOADTEXT_TYPE, role_vo.face_file, role_vo.face_update_time)
        --self.role_head:setLev(role_vo.lev)
        --local avatar_bid = role_vo.avatar_base_id
        --local vo = Config.AvatarData.data_avatar[avatar_bid]
        --if vo then
        --    local res_id = vo.res_id or 1
        --    local res = PathTool.getTargetRes("headcircle", "txt_cn_headcircle_" .. res_id, false, false)
        --    self.role_head:showBg(res, nil, false, vo.offy)
        --end

        if data.rank_list ~= nil and next(data.rank_list) ~= nil then
            if self.scroll_view == nil then
                local setting = {
                    item_class = GW_ArenaLoopRankItem,
                    start_x = 8,
                    space_x = 0,
                    start_y = 8,
                    space_y = 12,
                    item_width = 444,
                    item_height = 130,
                    row = 0,
                    col = 1,
                    need_dynamic = true
                }
                self.scroll_view = CommonScrollViewLayout.new(self.left_info_list_container, cc.p(0, 0), nil, nil, self.left_info_list_container_size, setting)
            end

            self.scroll_view:setData(data.rank_list)
            self.left_info_list_container:setVisible(true)
        else
            self.left_info_list_container:setVisible(false)
        end
    else
        self.left_info_list_container:setVisible(false)
    end
end

--更新点金红点
function GW_ArenaWindow:updataExchangeRedPoint()
    if not self.exchange_data then
        return
    end
    local red_lev_min =  Config.ConvertData.data_trade_cost.red_lev_min
    for i,v in ipairs(self.exchange_data.list) do
        if v.id == 1 and self.coin_redpoint then
            local status = false
            if (v.max - v.num) > 0 and role_vo and red_lev_min and red_lev_min.val <= role_vo.lev then
                status = true
            end
            if status == true then
                if self.coin_redpoint_spine == nil then
                    self.coin_redpoint_spine = PathTool.gw_createRedpointSpine()
                    self.coin_redpoint_spine:setPosition(40,32)
                    self.coin_redpoint:addChild(self.coin_redpoint_spine)
                end
                self.coin_redpoint_spine:setVisible(true)
                break
            else
                if self.coin_redpoint_spine then
                    self.coin_redpoint_spine:setVisible(false)
                end
            end
        end
    end
end
-- --------------------------------------------------------------------
-- @author: shiraho@syg.com(必填, 创建模块的人员)
-- @description:
--      循环赛排行榜单元
-- <br/>Create: new Date().toISOString()
--
-- --------------------------------------------------------------------
GW_ArenaLoopRankItem = class("GW_ArenaLoopRankItem",function()
    return ccui.Layout:create()
end)

function GW_ArenaLoopRankItem:ctor()
    self.root_wnd = createCSBNote(PathTool.getTargetCSB("gw_arena/gw_arena_window_rank_list_item"))
    self.size = self.root_wnd:getContentSize()
    self:setAnchorPoint(cc.p(0.5, 0.5))
    self:setContentSize(self.size)

    self.root_wnd:setAnchorPoint(0.5, 0.5)
    self.root_wnd:setPosition(self.size.width * 0.5, self.size.height * 0.5)
    self:addChild(self.root_wnd)

    self.bg = self.root_wnd:getChildByName("bg")
    self.rank_icon = self.root_wnd:getChildByName("rank_icon")
    self.rank_icon:setVisible(false)
    self.rank_num = self.root_wnd:getChildByName("rank_num")
    self.rank_num:setVisible(false)
    --self.rank_first = self.root_wnd:getChildByName("rank_first")
    --self.rank_second = self.root_wnd:getChildByName("rank_second")
    --self.rank_third = self.root_wnd:getChildByName("rank_third")
    --self.rank_num_bg = self.root_wnd:getChildByName("rank_num_bg")
    --self.rank_num = self.root_wnd:getChildByName("rank_num")
    self.head_info = self.root_wnd:getChildByName("head_info")
    self.head_info_lev = self.head_info:getChildByName("lev_bg"):getChildByName("lev_label")
    self.head_node = self.head_info:getChildByName("head_node")
    self.role_head = PlayerHead.new(PlayerHead.type.square, 0)
    self.role_head:setPosition(0, 0)
    self.role_head:setHeadLayerScale(1)
    self.head_node:addChild(self.role_head)
    --self.role_head:setLev(99)
    self.role_name = self.root_wnd:getChildByName("name")
    --self.lev_bg = self.root_wnd:getChildByName("lev_bg")
    --self.lev_label = self.root_wnd:getChildByName("lev_label")
    --self.role_power = self.root_wnd:getChildByName("battle_node"):getChildByName("num")
    self.score_node_num = self.root_wnd:getChildByName("score_node"):getChildByName("num")

    self.battle_node = self.root_wnd:getChildByName("battle_node")
    self.battle_info_spine = gw_createEffectSpine("E90136", cc.p(0, 0), cc.p(0.5, 0.5), true, "animation")
    self.battle_info_spine:setScale(0.70)
    self.battle_info_spine:setPositionY(-7)
    self.battle_node:addChild(self.battle_info_spine)
    self.battle_info_power = CommonNum.new(104, self.battle_node, nil, -18, cc.p(0, 0.5))
    self.battle_info_power:setScale(0.6)
    self.battle_info_power:setPositionX(15)
    self.battle_info_power:setPositionY(12)
    self.battle_info_power:setLocalZOrder(99)
    --self.battle_info_power:setCallBack(function()
    --    local power_size = self.recommend_battle_info_power:getContentSize()
    --    local total_width = self.recommend_battle_info_label:getContentSize().width + power_size.width + 40
    --    local pos_x = 288 - total_width*0.5
    --    self.recommend_battle_info_label:setPositionX(pos_x)
    --    pos_x = pos_x + self.recommend_battle_info_label:getContentSize().width + 30
    --    self.recommend_battle_info_spine:setPositionX(pos_x)
    --    pos_x = pos_x + 10
    --    self.recommend_battle_info_power:setPositionX(pos_x)
    --end)

    self.bg_res_id = nil
    --self.lev_bg_res_id = nil
    self:registerEvent()
end

function GW_ArenaLoopRankItem:registerEvent()
    self.role_head:addCallBack( function()
        if self.data ~= nil and self.data.srv_id ~= "" then
            if self.data.srv_id == "robot" then
                message(UI_TI18N(22030))
            else
                FriendController:getInstance():openFriendCheckPanel(true, {srv_id = self.data.srv_id, rid = self.data.rid})
            end
            --controller:requestLoopChallengeRoleInfo(self.data.rid, self.data.srv_id)
            --FriendController:getInstance():openFriendCheckPanel(true, {srv_id = self.data.srv_id, rid = self.data.rid})
        end
    end,false)
end

function GW_ArenaLoopRankItem:setData(data)
    local role_vo = RoleController:getInstance():getRoleVo()
    if data and role_vo then
        self.data = data
        StringUtil.gw_setRoleNickName2(self.role_name, data.name, 195)
        --StringUtil.gw_setNickName(self.role_name, data.name)
        self.head_info_lev:setString(data.lev)
        --self.role_power:setString(data.power)
        self.role_head:setHeadRes(data.face, false, LOADTEXT_TYPE, data.face_file, data.face_update_time)
        self.role_head:gw_showHeadFrame(data.avatar_bid or data.avatar_id)
        --self.role_head:setLev(data.lev)
        --local avatar_bid = data.avatar_id
        --local vo = Config.AvatarData.data_avatar[avatar_bid]
        --if vo then
        --    local res_id = vo.res_id or 1
        --    local res = PathTool.getTargetRes("headcircle", "txt_cn_headcircle_" .. res_id, false, false)
        --    self.role_head:showBg(res, cc.size(300,300), false, vo.offy)
        --end

        local bg_res_id = PathTool.getResFrame("gw_arena", "Ranking005")
        if data.rank == 1 then
            bg_res_id = PathTool.getResFrame("gw_arena", "Ranking005")
            local res = PathTool.getResFrame("gw_arena", "Ranking009")
            loadSpriteTexture(self.rank_icon, res, LOADTEXT_TYPE_PLIST)
            self.rank_icon:setVisible(true)
            self.rank_num:setVisible(false)
        elseif data.rank == 2 then
            bg_res_id = PathTool.getResFrame("gw_arena", "Ranking006")
            local res = PathTool.getResFrame("gw_arena", "Ranking010")
            loadSpriteTexture(self.rank_icon, res, LOADTEXT_TYPE_PLIST)
            self.rank_icon:setVisible(true)
            self.rank_num:setVisible(false)
        elseif data.rank == 3 then
            bg_res_id = PathTool.getResFrame("gw_arena", "Ranking007")
            local res = PathTool.getResFrame("gw_arena", "Ranking011")
            loadSpriteTexture(self.rank_icon, res, LOADTEXT_TYPE_PLIST)
            self.rank_icon:setVisible(true)
            self.rank_num:setVisible(false)
        else
            bg_res_id = PathTool.getResFrame("gw_arena", "Ranking008")
            self.rank_icon:setVisible(false)
            self.rank_num:setString(data.rank)
            self.rank_num:setVisible(true)
        end
        --local lev_bg_res_id = PathTool.getResFrame("gw_arena", "gw_arena_rank_item_lv_bg_4")
        --if data.rank <= 3 then
        --    bg_res_id = PathTool.checkRes(string_format("resource/gw_arena/gw_arena_rank_item_bg_%s.png", data.rank))
        --    lev_bg_res_id = PathTool.getResFrame("gw_arena", "gw_arena_rank_item_lv_bg_"..data.rank)
        --    self.rank_first:setVisible(data.rank == 1)
        --    self.rank_second:setVisible(data.rank == 2)
        --    self.rank_third:setVisible(data.rank == 3)
        --    self.rank_num_bg:setVisible(false)
        --    self.rank_num:setVisible(false)
        --else
        --    self.rank_first:setVisible(false)
        --    self.rank_second:setVisible(false)
        --    self.rank_third:setVisible(false)
        --    self.rank_num_bg:setVisible(true)
        --    self.rank_num:setVisible(true)
        --    self.rank_num:setString(data.rank)
        --end

        if self.bg_res_id == nil or self.bg_res_id ~= bg_res_id then
            self.bg_res_id = bg_res_id
            loadSpriteTexture(self.bg, self.bg_res_id, LOADTEXT_TYPE_PLIST)
            self.bg:setVisible(true)
        end
        --if self.lev_bg_res_id == nil or self.lev_bg_res_id ~= lev_bg_res_id then
        --    self.lev_bg_res_id = lev_bg_res_id
        --    loadSpriteTexture(self.rank_num_bg, self.lev_bg_res_id, LOADTEXT_TYPE_PLIST)
        --end

        --self.bg:setVisible(true)
        --self.lev_bg:setVisible(true)

        self.battle_info_power:setNum(data.power)
        self.score_node_num:setString(data.score)
    end
end

function GW_ArenaLoopRankItem:DeleteMe()
    if self.role_head then
        self.role_head:DeleteMe()
        self.role_head = nil
    end
    if self.battle_info_spine then
        self.battle_info_spine:clearTracks()
        self.battle_info_spine:removeFromParent()
        self.battle_info_spine = nil
    end
    self:removeAllChildren()
    self:removeFromParent()
end