---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by gw.
--- DateTime: 2021/10/14 9:51
---
GW_EnterWindow = GW_EnterWindow or BaseClass(BaseView)

local string_format = string.format
local table_sort = table.sort
local table_insert = table.insert
local table_remove = table.remove

function GW_EnterWindow:__init()
    self.ctrl = LoginController:getInstance()
    self.is_full_screen = true
    self.layout_name = "login/gw_enter_window"
    self.win_type = WinType.Tips
    self.view_tag = ViewMgrTag.DIALOGUE_TAG

    self.res_list = {
        { path = PathTool.getPlistImgForDownLoad("gw_login", "gw_login"), type = ResourcesType.plist },
        { path = PathTool.getPlistImgForDownLoad("gw_login","bg_denglu", true), type = ResourcesType.single },
    }
end

function GW_EnterWindow:openRootWnd(login_success_data)
    self.agree_service_agreement = SysEnv:getInstance():getBool(SysEnv.keys.user_proto_agree, true)
    self.login_success_data = login_success_data

    self.cur_server_id = nil
    self.cur_server_name = nil
    self.cur_server_ip = nil
    self.cur_server_port = nil
    self.cur_server_is_new = nil
    self.cur_server_state = nil
    if self.login_success_data ~= nil then
        if self.login_success_data.roleInfos ~= nil and next(self.login_success_data.roleInfos) ~= nil then
            for i,role in pairs(self.login_success_data.roleInfos) do
                if role ~= nil and role.serverInfo ~= nil then
                    self.cur_server_id = role.serverInfo.id
                    self.cur_server_name = role.serverInfo.name
                    self.cur_server_ip = role.serverInfo.ip
                    self.cur_server_port = role.serverInfo.port
                    self.cur_server_is_new = role.serverInfo.isNew
                    self.cur_server_state = role.serverInfo.state
                    break
                end
            end
        end
        if self.cur_server_id == nil then
            if self.login_success_data.serverInfos ~= nil and next(self.login_success_data.serverInfos) ~= nil then
                for i,serverInfo in pairs(self.login_success_data.serverInfos) do
                    if serverInfo ~= nil then
                        self.cur_server_id = serverInfo.id
                        self.cur_server_name = serverInfo.name
                        self.cur_server_ip = serverInfo.ip
                        self.cur_server_port = serverInfo.port
                        self.cur_server_is_new = serverInfo.isNew
                        self.cur_server_state = serverInfo.state
                        break
                    end
                end
            end
        end
    end

    self:refreshCurServerItem()
    --self.checkbox.normal:setVisible(not self.agree_service_agreement)
    self.checkbox.selected:setVisible(self.agree_service_agreement)
end

function GW_EnterWindow:open_callback()
    self.mask = self.root_wnd:getChildByName("mask")
    self.mask:setScale(display.getMaxScale())
    self.background = self.root_wnd:getChildByName("background")
    self.background:setScale(display.getMaxScale())
    if self.background ~= nil then
        local bg_res = PathTool.getPlistImgForDownLoad("gw_login", "bg_denglu", true)
        loadSpriteTexture(self.background, bg_res, LOADTEXT_TYPE)
    end

    local spine1_node = self.root_wnd:getChildByName("spine1_node")
    self.spine1 = createEffectSpine("E80023", cc.p(0, 0), cc.p(0.5, 0.5), true, "action")
    spine1_node:addChild(self.spine1)

    local spine2_node = self.root_wnd:getChildByName("spine2_node")
    self.spine2 = createEffectSpine("E80024", cc.p(0, 0), cc.p(0.5, 0.5), true, "action")
    spine2_node:addChild(self.spine2)

    local spine3_node = self.root_wnd:getChildByName("spine3_node")
    self.spine3 = createEffectSpine("E80025", cc.p(0, 0), cc.p(0.5, 0.5), true, "action")
    spine3_node:addChild(self.spine3)

    local spine4_node = self.root_wnd:getChildByName("spine4_node")
    self.spine4 = createEffectSpine("E80026", cc.p(0, 0), cc.p(0.5, 0.5), true, "action")
    spine4_node:addChild(self.spine4)

    --self.age_tips_btn = self.root_wnd:getChildByName("age_tips_btn")
    --self.age_tips_btn:setPositionX(display.getRight() - 58)
    --self.age_tips_btn:setPositionY(display.getTop() - 70)
    self.change_account_btn = self.root_wnd:getChildByName("change_account_btn")
    self.change_account_btn:setPositionX(display.getRight() - 61)
    self.change_account_btn:setPositionY(display.getTop() - 153)

    self.notice_btn = self.root_wnd:getChildByName("notice_btn")
    self.notice_btn:setPositionX(display.getRight() - 61)
    self.notice_btn:setPositionY(display.getTop() - 68)

    self.main_container = self.root_wnd:getChildByName("main_container")
    self.main_container:setPositionY(display.getBottom())

    self.enter_btn = self.main_container:getChildByName("enter_btn")
    self.enter_btn:getChildByName("label"):setString(UI_TI18N(6085))
    self.checkbox = self.main_container:getChildByName("checkbox")
    --self.checkbox.normal = self.checkbox:getChildByName("normal")
    self.checkbox.selected = self.checkbox:getChildByName("selected")

    self.server_item = self.main_container:getChildByName("server_item")
    self.server_item.state_icon = self.server_item:getChildByName("state_icon")
    self.server_item.label = self.server_item:getChildByName("label")

    self.service_agreement_label = createRichLabel(22, cc.c4b(0xff,0xff,0xff,0xff), cc.p(0,1), cc.p(320.00,114.00), 0, 0, 700)
    self.main_container:addChild(self.service_agreement_label)
    --self.tips_label = createRichLabel(20, cc.c4b(0x39,0x3a,0x3b,0xff), cc.p(0.5,1), cc.p(640,60.00), 5, 0, 1500)
    --self.main_container:addChild(self.tips_label)

    --self.tips_label:setString(UI_TI18N(6043))
    self.service_agreement_label:setString(UI_TI18N(6044))
    self.service_agreement_label:addTouchLinkListener(function(type, value, sender, pos)
        if value == "onclick_1" then
            if GW_NEW_LOGIN_USER_AGREEMENT_URL == nil or GW_NEW_LOGIN_USER_AGREEMENT_URL == "" then
                FunctionNotOpenTips()
            else
                --用户协议
                local value = GW_NEW_LOGIN_USER_AGREEMENT_URL
                if IS_IOS_PLATFORM == true then
                    sdkCallFunc("openSyW", value)
                else
                    sdkCallFunc("openUrl", value)
                end
            end
        elseif value == "onclick_2" then
            if GW_NEW_LOGIN_PRIVACY_GUIDELINES_URL == nil or GW_NEW_LOGIN_PRIVACY_GUIDELINES_URL == "" then
                FunctionNotOpenTips()
            else
                --隐私保护
                local value = GW_NEW_LOGIN_PRIVACY_GUIDELINES_URL
                if IS_IOS_PLATFORM == true then
                    sdkCallFunc("openSyW", value)
                else
                    sdkCallFunc("openUrl", value)
                end
            end
        end
    end, { "click", "href" })
    --local total_len = self.service_agreement_label:getContentSize().width + 50
    --self.checkbox:setPositionX(640 - (total_len*0.5) + 25)
    --self.service_agreement_label:setPositionX(640 - (total_len*0.5) + 50)


    ----播放窗口动画
    --self:playEnterAnimatianByObj(self.main_container , 2)
end

function GW_EnterWindow:register_event()
    --registerButtonEventListener(self.age_tips_btn, handler(self, self.onClickAgeTipsBtn) ,true, REGISTER_BUTTON_SOUND_BUTTON_TYPY)
    registerButtonEventListener(self.change_account_btn, handler(self, self.onClickChangeAccountBtn) ,true, REGISTER_BUTTON_SOUND_BUTTON_TYPY)
    registerButtonEventListener(self.notice_btn, handler(self, self.onClickNoticeBtn) ,true, REGISTER_BUTTON_SOUND_BUTTON_TYPY)
    registerButtonEventListener(self.enter_btn, handler(self, self.onClickEnterBtn) ,true, REGISTER_BUTTON_SOUND_BUTTON_TYPY)
    registerButtonEventListener(self.checkbox, handler(self, self.onClickCheckboxBtn) ,true, REGISTER_BUTTON_SOUND_BUTTON_TYPY)
    registerButtonEventListener(self.server_item, handler(self, self.onClickServerItemBtn) ,true, REGISTER_BUTTON_SOUND_BUTTON_TYPY)

    --选择服务器成功
    if not self.gw_select_server_success then
        self.gw_select_server_success = GlobalEvent:getInstance():Bind(LoginEvent.GW_SELECT_SERVER_SUCCESS, function(data)
            if data ~= nil then
                self.cur_server_id = data.server_id
                self.cur_server_name = data.server_name
                self.cur_server_ip = data.server_ip
                self.cur_server_port = data.server_port
                self.cur_server_is_new = data.server_is_new
                self.cur_server_state = data.server_state
                self:refreshCurServerItem()
                self:onClickEnterBtn()
            end
        end)
    end
end

function GW_EnterWindow:close_callback()
    if self.gw_select_server_success then
        GlobalEvent:getInstance():UnBind(self.gw_select_server_success)
        self.gw_select_server_success = nil
    end

    if self.spine1 ~= nil then
        self.spine1:clearTracks()
        self.spine1:removeFromParent()
        self.spine1 = nil
    end
    if self.spine2 ~= nil then
        self.spine2:clearTracks()
        self.spine2:removeFromParent()
        self.spine2 = nil
    end
    if self.spine3 ~= nil then
        self.spine3:clearTracks()
        self.spine3:removeFromParent()
        self.spine3 = nil
    end
    if self.spine4 ~= nil then
        self.spine4:clearTracks()
        self.spine4:removeFromParent()
        self.spine4 = nil
    end

    self.ctrl:gw_closeEnterWindow()
end
--==============================--
--desc:移除ui这个操作只有在切换账号的时候触发
--time:2021-06-29 10:51:38
--@return
--==============================--
function GW_EnterWindow:__delete()
    Debug.log("GW_EnterWindow:__delete()")
end

--点击适龄提示
function GW_EnterWindow:onClickAgeTipsBtn(force)
    FunctionNotOpenTips()
end
--点击账号切换
function GW_EnterWindow:onClickChangeAccountBtn(force)
    SysEnv:getInstance():set(SysEnv.keys.gw_auto_login_type, 0, true)
    SysEnv:getInstance():set(SysEnv.keys.gw_auto_login_account, "", true)
    SysEnv:getInstance():set(SysEnv.keys.gw_auto_login_password, "", true)

    --self.ctrl:gw_openLoginWindow(GW_LoginWindow.type.base_panel)
    --self.ctrl:gw_closeEnterWindow()

    AudioManager:getInstance():stopMusic()
    sdkOnSwitchAccount()
end
--点击公告
function GW_EnterWindow:onClickNoticeBtn(force)
    NoticeController:getInstance():openNoticeView()
end
--点击开始游戏
function GW_EnterWindow:onClickEnterBtn(force)
    if self.agree_service_agreement == false then

        local str = UI_TI18N(6045)

        local confirm_callback = function()
            self:onClickCheckboxBtn()
            self:onClickEnterBtn()
        end
        local cancel_callback = function()
        end

        CommonAlert.show( str, UI_TI18N(13002), confirm_callback, UI_TI18N(13003), cancel_callback, nil, cancel_callback, {timer=0})

        return
    end

    if self.cur_server_id == nil or self.cur_server_ip == nil or self.cur_server_port == nil then
        message(UI_TI18N(6046))
        return
    end

    --if self.cur_server_state == nil or self.cur_server_state == 3 then
    --    message(UI_TI18N(6047))
    --    return
    --end

    self.ctrl:getModel().loginData.ip = self.cur_server_ip
    self.ctrl:getModel().loginData.port = self.cur_server_port
    --self.ctrl:getModel().loginData.status = self.cur_server_state
    self.ctrl:getModel().loginData.isNew = self.cur_server_is_new
    self.ctrl:getModel().loginData.srv_name = self.cur_server_name
    self.ctrl:getModel().loginData.srv_id = self.cur_server_id
    self.ctrl:requestLoginGame(self.login_success_data.mainAccount, self.cur_server_ip, self.cur_server_port, true, true)
end
--点击勾选或取消勾选服务协议
function GW_EnterWindow:onClickCheckboxBtn(force)
    if self.agree_service_agreement == nil or self.agree_service_agreement == false then
        self.agree_service_agreement = true
    else
        self.agree_service_agreement = false
    end

    SysEnv:getInstance():set(SysEnv.keys.user_proto_agree, self.agree_service_agreement, true)
    --self.checkbox.normal:setVisible(not self.agree_service_agreement)
    self.checkbox.selected:setVisible(self.agree_service_agreement)
end
--点击当前服务器选项打开服务器选择列表面板
function GW_EnterWindow:onClickServerItemBtn(force)
    if self.agree_service_agreement == false then
        message(UI_TI18N(6048))
        return
    end

    self.ctrl:gw_openServerListWindow(self.login_success_data)
end
--刷新当前服务器信息
function GW_EnterWindow:refreshCurServerItem()
    self.server_item.state_icon = self.server_item:getChildByName("state_icon")
    if self.cur_server_name ~= nil then
        self.server_item.label:setString(self.cur_server_name)
    else
        self.server_item.label:setString("")
    end

    if self.cur_server_state ~= nil then
        local res = "gw_login_10_icon_zhuangtai1"--维护
        if self.cur_server_state == 1 then
            res = "gw_login_8_icon_zhuangtai1"--火爆
        elseif self.cur_server_state == 2 then
            res = "gw_login_9_icon_zhuangtai2"--流畅
        end
        local res = PathTool.getResFrame("gw_login", res)
        loadSpriteTexture(self.server_item.state_icon, res, LOADTEXT_TYPE_PLIST)
        self.server_item.state_icon:setVisible(true)
    else
        self.server_item.state_icon:setVisible(false)
    end
    
end