-- --------------------------------------------------------------------
-- 游戏公告
-- 
-- @author: cloud@syg.com(必填, 创建模块的人员)
-- @editor: xxx@syg.com(必填, 后续维护以及修改的人员)
-- @description:
--      这里填写详细说明,主要填写该模块的功能简要
-- <br/>Create: 2017-8-8
-- --------------------------------------------------------------------
NoticeWindow = NoticeWindow or BaseClass(BaseView)

local ccfile = cc.FileUtils:getInstance()
function NoticeWindow:__init(url, close_to_login)
    self.close_to_login = close_to_login or false
    self.url = url
    self.view_tag = ViewMgrTag.DIALOGUE_TAG
    self.ctrl = NoticeController:getInstance()
    self.layout_name = "notice/notice_window"
    self.win_type = WinType.Mini
    self.dengluMgr = LoginController:getInstance():getModel()
    self.title_height = 0
    self.title = ""
end

function NoticeWindow:open_callback()
    local background = self.root_wnd:getChildByName("background")
    background:setScale(display.getMaxScale())

    self.main_panel = self.root_wnd:getChildByName("main_container")
    self:playEnterAnimatianByObj(self.main_panel , 2)
    self.close_btn = self.main_panel:getChildByName("close_btn")

    local win_title = self.main_panel:getChildByName("title")
    win_title:setString(UI_TI18N(28030))
    --
    --self.ok_btn = self.main_panel:getChildByName("ok_btn")
    --self.ok_btn_label = self.ok_btn:getChildByName("label")
    --self.ok_btn_label:setString(TI18N("确定"))
    --self.ok_btn_label:enableOutline(Config.ColorData.data_color4[264], 2)
    --
    self.container = self.main_panel:getChildByName('container')
    self.container_size = self.container:getContentSize()
    self.container:setVisible(false)
    --
    --self.txt_container = self.container:getChildByName("txt_container")
    --
    --self.txt_title = self.txt_container:getChildByName("txt_title")
    --self.notice_scroll = self.txt_container:getChildByName("notice_scroll")
    --self.notice_scroll:setScrollBarEnabled(false)
    --self.container_size = self.notice_scroll:getContentSize()
    --
    --self:layoutWebView()
    --self:setMessage(self.url)

    self:gw_setMessage()
end

-- 分离处理webview，如果有问题可以只修改局部代码
function NoticeWindow:layoutWebView()
    if self.url and self.url ~= "" and ccexp.WebView then
        self.main_panel:getChildByName("win_title"):setString("vip")
        self.web_view = ccexp.WebView:create()
        self.web_view:setAnchorPoint(0.5, 0.5)
        self.web_view:setPosition(self.container_size.width * 0.5 + 10, self.container_size.height * 0.5)
        self.web_view:setContentSize(self.container_size.width + 20, 740)
        self.web_view:setScalesPageToFit(true)
        self.web_view:setVisible(false)
        self.container:addChild(self.web_view, 99)
        self.txt_container:setVisible(false)
    end
end

function NoticeWindow:register_event()
    --local bg_res = ""
    --if self.cur_index == 1 then
    --    bg_res = PathTool.getPlistImgForDownLoad("gw_action", "gw_action_treasure_01_b_bg_zhuanpan1", true)
    --else
    --    bg_res = PathTool.getPlistImgForDownLoad("gw_action", "gw_action_treasure_01_b_bg_zhuanpan2", true)
    --end
    --if self.background_load then
    --    self.background_load:DeleteMe()
    --    self.background_load = nil
    --end
    --self.background_load = loadImageTextureFromCDN(self.background, bg_res, ResourcesType.single, self.background_load)
    self.close_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            self.ctrl:closeNoticeView()
            if self.close_to_login == true then
                if LoginController:getInstance():gw_isEnterWindowOpening() == false then
                    AudioManager:getInstance():stopMusic()
                    sdkOnSwitchAccount()
                end
            end
        end
    end)
    --self.ok_btn:addTouchEventListener(function(sender, event_type)
    --    if event_type == ccui.TouchEventType.ended then
    --        playButtonSound2()
    --        --self.ctrl:closeNoticeView()
    --        self:gw_testPostHttp()
    --    end
    --end)
end

function NoticeWindow:setMessage(url)
    if not tolua.isnull(self.web_view) then
        self.web_view:setVisible(false)         -- webview要特殊处理setvisible
    end
    if url then
        self:setWebViewUrl(url)
    else
        self.ok_btn:setVisible(true)
        self.notice_content = self.ctrl:getNoticeContent()
        if self.notice_content == nil then
            local loginData = serverData or self.dengluMgr:getLoginData()
            local svrTime = loginData.open_time or 0
            local svrDays = 0
            if svrTime ~= 0 and svrTime ~= nil then
                svrDays = math.ceil((os.time() - svrTime)/TimeTool.day2s())
            end
            local srvurl = get_notice_url(svrDays, loginData)
            -- local srvurl = "http://cdn.demo.zsyz.shiyuegame.com/api.php/local/local/notice/"
            if srvurl then
                function OnFileDownloadResult(state, name)
                    if self.root_wnd == nil or tolua.isnull(self.root_wnd) then return end
                    local f = assert(io.open(string.format("%sassets/src/%s", cc.FileUtils:getInstance():getWritablePath(), name), "r"))
                    local str = f:read("*all")
                    local str_table = loadstring("return "..str)
                    if str_table == nil then
                        str_table = {}
                    else
                        str_table = str_table()
                    end
                    f:close()
                    local str
                    if str_table and str_table.data and str_table.data[1] and str_table.data[1].content then 
                        str = str_table.data[1].content or ""
                    end
                    if not str then return end
                    str = string.gsub(str, "&lt;", "<")
                    str = string.gsub(str, "&gt;", ">")
                    str = string.gsub(str, "&#039;", "'")
                    str = string.gsub(str, "&quot;", '"')  
                    str = string.gsub(str, "\9", '    ')                     
                    str = WordCensor:getInstance():relapceFaceIconTag(str)[2]

                    self.notice_content = str
                    NoticeController:getInstance():setNoticeContent(str)        -- 缓存一下这一次的公告

                    local list = Split(str, "|")
                    self:addNoticeContent(list)
                end
                cc.FmodexManager:getInstance():downloadOtherFile(srvurl, "notice.txt")
            end
        else
            local list = Split(self.notice_content, "|")
            self:addNoticeContent(list)
        end
    end
end

function NoticeWindow:setWebViewUrl(url)
    if not self.web_view then return end
    if not tolua.isnull(self.web_view) then
        self.web_view:setVisible(true)
    end
    self.web_view:loadURL(url)
    self.ok_btn:setVisible(false)
end

function NoticeWindow:addNoticeContent(list)
	if list == nil or #list == 0 then return end
	-- 更新先情况,防止加载不到文件时候多次加载
	self.notice_scroll:removeAllChildren()
	self.notice_scroll:stopAllActions()
	local len = #list
	local vo = nil
	local curY = 6
	local idx = 1
	local contentList = {}

    -- 取出第一个用于称谓显示
    local first_txt = table.remove( list, 1 )
    self.txt_title:setString(first_txt or "")

    for i,vo in ipairs(list) do
        delayRun(self.notice_scroll, i/60, function() 
			local sub = self:createSubContent(2, 0, vo, self.container_size.width-4, 6)
			curY = curY + sub:getContentSize().height + 3
			table.insert(contentList, sub)

			local maxY = math.max(curY, self.container_size.height)
			local size = cc.size(self.container_size.width, maxY)
			self.notice_scroll:setInnerContainerSize(size)

			for i, obj in ipairs(contentList) do
				obj:setPositionY(maxY-10)
				maxY = maxY - (obj:getContentSize().height + 3)
			end
        end)
    end
end

function NoticeWindow:createSubContent(x, y, content, width, linespace)
	local label = createRichLabel(22, Config.ColorData.data_color4[274], nil, cc.p(0, 1), linespace, nil, width)
	label:setString(content)
	label:setAnchorPoint(0, 1)
	self.notice_scroll:addChild(label)
	label:setPosition(x, y)
	return label
end

function NoticeWindow:close_callback()
    doStopAllActions(self.notice_scroll)
    self.url = nil
    self.img_load_finish = nil
    self.content_load_finish = nil
    self.img_url = nil
    self.content_url = nil
    self.img_show = false
    self.content_show = false
    self.ctrl:closeNoticeView()
end

function NoticeWindow:gw_setMessage()
    local img_url = "http://192.168.3.24/notice/img/1.png"
    local content_url = "http://192.168.3.24/notice/content/1.txt"

    if self.close_to_login == true then
        if gw_get_notice_img_url_under_maintenance and gw_get_notice_content_url_under_maintenance then
            local svrDays = 0
            local svrOpenTime = RoleController:getInstance():getModel():getSrvDay()
            if svrOpenTime ~= 0 and svrOpenTime ~= nil then
                svrDays = math.ceil((os.time() - svrOpenTime)/TimeTool.day2s())
            end
            img_url = gw_get_notice_img_url_under_maintenance(svrDays)
            content_url = gw_get_notice_content_url_under_maintenance(svrDays)
        end
    else
        if gw_get_notice_img_url and gw_get_notice_content_url then
            local svrDays = 0
            local svrOpenTime = RoleController:getInstance():getModel():getSrvDay()
            if svrOpenTime ~= 0 and svrOpenTime ~= nil then
                svrDays = math.ceil((os.time() - svrOpenTime)/TimeTool.day2s())
            end
            img_url = gw_get_notice_img_url(svrDays)
            content_url = gw_get_notice_content_url(svrDays)
        end
    end

    self.img_load_finish = false
    self.content_load_finish = false
    self.img_url = img_url
    self.content_url = content_url
    self.img_show = false
    self.content_show = false
    if img_url ~= nil and img_url ~= "" then
        self.img_show = true
    else
        self.img_load_finish = true
    end
    if content_url ~= nil and content_url ~= "" then
        self.content_show = true
    else
        self.content_load_finish = true
    end

    self:gw_startLoad()
end

function NoticeWindow:gw_startLoad()
    if self.img_load_finish == nil or self.content_load_finish == nil then
        return
    end

    if self.img_load_finish == false then
        self:gw_loadImg()
        return
    end

    if self.content_load_finish == false then
        self:gw_loadContent()
        return
    end

    self:gw_layoutMessage()
end

function NoticeWindow:gw_layoutMessage()
    if self.img_load_finish == nil or self.content_load_finish == nil then
        return
    end

    if self.content_scroll_view == nil then
        self.content_scroll_view = createScrollView(self.container_size.width, self.container_size.height, 0, 0, self.container, ccui.ScrollViewDir.vertical)
        self.content_scroll_view:scrollToTop(0.1, false)
        self.content_scroll_view:setScrollBarEnabled(false)
    end

    local max_height = 29
    if self.img_show == true then
        if self.gw_notice_img == nil then
            local res = PathTool.gw_getNoticePath()
            self.gw_notice_img = createSprite(res, 40, 0, self.content_scroll_view, cc.p(0, 1), LOADTEXT_TYPE)
        end

        max_height = max_height + 142 + 32
    else
        if self.gw_notice_img then
            self.gw_notice_img:setVisible(false)
        end
    end

    if self.content_show == true and self.content_str ~= nil then
        if self.gw_notice_content == nil then
            self.gw_notice_content = createRichLabel(24, cc.c4b(0x62,0x6b,0x73,0xff), cc.p(0, 1), cc.p(40,0), nil, nil, 1050)
            self.content_scroll_view:addChild(self.gw_notice_content)
        end

        self.gw_notice_content:setString(self.content_str)

        max_height = max_height + self.gw_notice_content:getContentSize().height + 32
    else
        if self.gw_notice_content then
            self.gw_notice_content:setVisible(false)
        end
    end

    max_height = math.max(max_height, 500)
    self.content_scroll_view:setInnerContainerSize(cc.size(self.container_size.width, max_height))
    self.content_scroll_view:jumpToTop()

    max_height = max_height - 29
    if self.img_show == true then
        self.gw_notice_img:setPositionY(max_height)

        max_height = max_height - 142 - 32
    end
    if self.content_show == true and self.content_str ~= nil then
        self.gw_notice_content:setPositionY(max_height)
    end

    self.container:setVisible(true)
end

function NoticeWindow:gw_loadImg()
    local dir_path = string.format("%sassets/src/notice/", cc.FileUtils:getInstance():getWritablePath())
    if not cc.FileUtils:getInstance():isDirectoryExist(dir_path) then
        cc.FileUtils:getInstance():createDirectory(dir_path)
    end

    --local local_file = PathTool.gw_getNoticePath()
    --local isFileExist = ccfile:isFileExist(local_file)
    --if isFileExist then
    --
    --end
    function OnFileDownloadResult(status, name)
        if self.img_load_finish == nil or self.content_load_finish == nil then
            return
        end

        if status == 0 then--下载成功

        else
            Debug.error("下载公告图片失败！！url:"..self.img_url)
        end
        self.img_load_finish = true
        self:gw_startLoad()
    end
    cc.FmodexManager:getInstance():downloadOtherFile(self.img_url, "notice/gw_notice_img.png")
end

function NoticeWindow:gw_loadContent()
    function OnFileDownloadResult(status, name)
        if self.img_load_finish == nil or self.content_load_finish == nil then
            return
        end

        self.content_str = nil

        if status == 0 then--下载成功
            local filename = string.format("%sassets/src/%s", cc.FileUtils:getInstance():getWritablePath(), name)
            local file = assert(io.open(filename, "r"))
            local str = file:read("*all")
            file:close()
            local load_ok, load_msg = pcall(function() loadstring(str or "")() end)
            if load_ok then--下载公告文件成功

            else--下载公告文件失败
                Debug.error("解析公告文件失败！！！url:"..self.content_url)
            end

            local content_str = gw_get_notice_content()
            if content_str then
                self.content_str = content_str
            end
        else
            Debug.error("下载公告文件失败！！！url:"..self.content_url)
        end

        self.content_load_finish = true
        self:gw_startLoad()
    end
    cc.FmodexManager:getInstance():downloadOtherFile(self.content_url, "gw_notice_content.txt")
end

--function NoticeWindow:gw_testPostHttp()
--    local body = {}
--    body.ActionId = 1
--    body.MachineCode = getIdFa()
--    body.Channel = "google"
--    body.ClientVersion = 100
--    body.Platform = "ios"
--    body.Data = {}
--    body.Data.PhoneNum = "09251234567"
--    body.Data.SendType = 1
--    --Debug.info(body)
--    local json_str = json.encode(body)
--    Debug.info(json_str)
--    --local tmp_body = string.format("body_str=%s", json_str)
--
--    local xhr = cc.XMLHttpRequest:new()
--    xhr:setRequestHeader("auth","123456")
--    xhr:setRequestHeader("Content-Type","application/json")
--    xhr.responseType = cc.XMLHTTPREQUEST_RESPONSE_JSON
--    xhr:open("POST", "http://192.168.3.14:53966/api/WebService/Handle")
--    local function onReadyStateChange()
--        print("xhr.readyState:"..xhr.readyState)
--        print("xhr.status:"..xhr.status)
--        if xhr.readyState == 4 and (xhr.status >= 200 and xhr.status < 207) then
--            local response = xhr.response
--            local parseTable = json.decode(response,1)
--            print(response)
--            Debug.info(parseTable)
--            --local servers = loadstring("return " .. response)
--            --if servers == nil then
--            --    servers = {}
--            --else
--            --    servers = servers()
--            --end
--            --self:managerDefualtServerListByJsonObj(servers, account, platform)
--        else
--            --delayRun(ViewManager:getInstance():getLayerByTag(ViewMgrTag.MSG_TAG), 2, function()
--            --    if self:useLocalServerData() == false then -- 如果本地缓存没有默认服务器,则继续请求
--            --        self:requestDefaultServerList(account, platform)
--            --    end
--            --end)
--        end
--    end
--    --local body = self:getRequestExtend(body, channelId, account)页签推荐
--    xhr:registerScriptHandler(onReadyStateChange)
--    xhr:send(json_str)
--end