-- --------------------------------------------------------------------
-- 福利主界面
--
-- @author: shuwen@syg.com(必填, 创建模块的人员)
-- @editor: xxx@syg.com(必填, 后续维护以及修改的人员)
-- @description:
--      这里填写详细说明,主要填写该模块的功能简要
-- <br/>Create: {DATE}
-- --------------------------------------------------------------------
WelfareMainWindow = WelfareMainWindow or BaseClass(BaseView)

local string_format = string.format
local table_insert = table.insert
local table_sort = table.sort
local controller = WelfareController:getInstance()
local model = controller:getModel()
local action_controller = ActionController:getInstance()
local gw_role_vo = RoleController:getInstance():getRoleVo()

function WelfareMainWindow:__init()
    self.is_full_screen = true
    self.win_type = WinType.Full  
    self.layout_name = "welfare/gw_welfare_main_view"
    self.res_list = {
        { path = PathTool.getPlistImgForDownLoad("gw_welfare","gw_welfare"), type = ResourcesType.plist},
        { path = PathTool.getPlistImgForDownLoad("gw_welfare","gw_welfare_01", false), type = ResourcesType.single },
        --{ path = PathTool.getPlistImgForDownLoad("gw_welfare","gw_welfare_05", false), type = ResourcesType.single },
        --{ path = PathTool.getPlistImgForDownLoad("gw_welfare","gw_welfare_16", false), type = ResourcesType.single },
        --{ path = PathTool.getPlistImgForDownLoad("gw_welfare","gw_welfare_17", false), type = ResourcesType.single },
        --{ path = PathTool.getPlistImgForDownLoad("gw_welfare","gw_welfare_18_2", false), type = ResourcesType.single },
    } 

    self.tab_list = {}
    self.tab_width = 78
    self.off_space = 50
    self.panel_list = {}
    self.selected_tab = nil 
    self.selected_panel = nil

end

function WelfareMainWindow:open_callback()
    self.root_wnd:getChildByName("background"):setScale(display.getMaxScale())

    self.main_container = self.root_wnd:getChildByName("main_container")
    self:playEnterAnimatianByObj(self.main_container , 1)

    self.background = self.main_container:getChildByName("background")
    local bg_res = PathTool.getPlistImgForDownLoad("gw_welfare", "gw_welfare_01", false)
    if not self.background_load then
        self.background_load = loadSpriteTextureFromCDN(self.background, bg_res, ResourcesType.single, self.background_load)
    end
    self.close_btn = self.main_container:getChildByName("close_btn")
    self.close_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender,event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            controller:openMainWindow(false)
        end
    end)

    self.sheet1_container = self.main_container:getChildByName("sheet1_container")
    self.sheet1_container:setVisible(false)
    self.sheet2_container = self.main_container:getChildByName("sheet2_container")
    self.sheet2_container:setVisible(false)
    self.sheet3_container = self.main_container:getChildByName("sheet3_container")
    self.sheet3_container:setVisible(false)
    self.sheet4_container = self.main_container:getChildByName("sheet4_container")
    self.sheet4_container:setVisible(false)
    self.panel_container = self.main_container:getChildByName("panel_container")

    local sheet_bid_list = {WelfareIcon.yueka,WelfareIcon.bindphone,991008,WelfareIcon.wechat,WelfareIcon.subscribe}
    self.sheet_container = self.main_container:getChildByName("sheet_container")
    self.sheet_btn_list = {}
    for i=1,5 do
        self.sheet_btn_list[i] = self.sheet_container:getChildByName("sheet"..i)
        self.sheet_btn_list[i]:addTouchEventListener(function(sender, event_type)
            customClickAction_4(sender,event_type)
            if event_type == ccui.TouchEventType.ended then
                playButtonSound2()
                self:onClickSheet(i)
            end
        end)
        self.sheet_btn_list[i].bid = sheet_bid_list[i]
        self.sheet_btn_list[i].normal = self.sheet_btn_list[i]:getChildByName("normal")
        self.sheet_btn_list[i].normal:setVisible(false)
        self.sheet_btn_list[i].normal_label = self.sheet_btn_list[i].normal:getChildByName("label")
        self.sheet_btn_list[i].select = self.sheet_btn_list[i]:getChildByName("select")
        self.sheet_btn_list[i].select:setVisible(false)
        self.sheet_btn_list[i].select_label = self.sheet_btn_list[i].select:getChildByName("label")
        self.sheet_btn_list[i].redpoint = self.sheet_btn_list[i]:getChildByName("redpoint")

        local config = Config.HolidayClientData.data_info[self.sheet_btn_list[i].bid]
        if config == nil then
            Debug.error("找不到活动配置！！holiday_client_data.xml id:"..self.sheet_btn_list[self.sheet].bid)
        else
            self.sheet_btn_list[i].normal_label:setString(config.title)
            self.sheet_btn_list[i].select_label:setString(config.title)

            self.sheet_btn_list[i].normal_label:setFontSize(28)
            if self.sheet_btn_list[i].normal_label:getContentSize().width > 210 then
                for k=1,10 do
                    self.sheet_btn_list[i].normal_label:setFontSize(28-k)
                    if self.sheet_btn_list[i].normal_label:getContentSize().width <= 210 then
                        break
                    end
                end
            end
            self.sheet_btn_list[i].select_label:setFontSize(30)
            if self.sheet_btn_list[i].select_label:getContentSize().width > 220 then
                for k=1,10 do
                    self.sheet_btn_list[i].select_label:setFontSize(30-k)
                    if self.sheet_btn_list[i].select_label:getContentSize().width <= 220 then
                        break
                    end
                end
            end
        end
    end

    --if self.background ~= nil then
    --    loadSpriteTexture(self.background, PathTool.getPlistImgForDownLoad("bigbg/welfare","welfare_bg"), LOADTEXT_TYPE)
    --    self.background:setScale(display.getMaxScale())
    --end
    --self.main_container = self.root_wnd:getChildByName("main_container")
    --self.main_container:setPositionY(display.getTop()-196)
    --
    --local main_panel = self.main_container:getChildByName("main_panel")
    --self.container = main_panel:getChildByName("container")
    --self.tab_sprite_bg = main_panel:getChildByName("tab_sprite_bg")
    --loadSpriteTexture(self.tab_sprite_bg, PathTool.getPlistImgForDownLoad("bigbg/welfare","welfare_bg_1"), LOADTEXT_TYPE)
    --
    --local tab_container = self.root_wnd:getChildByName("tab_container")
    --self.close_btn = tab_container:getChildByName("close_btn")
    ----local bottom_height = MainuiController:getInstance():getMainUi():getBottomHeight()
    ----self.close_btn:setPositionY(display.getBottom()+bottom_height+25)
    --
    --local scroll_container = self.root_wnd:getChildByName("scroll_container")
    --local sprite_tab = scroll_container:getChildByName("sprite_tab")
    --loadSpriteTexture(sprite_tab, PathTool.getPlistImgForDownLoad("bigbg/welfare","welfare_tab"), LOADTEXT_TYPE)
    --
    --scroll_container:setPositionY(display.getTop())
    --local top_sprite1 = scroll_container:getChildByName("top_sprite1")
    --top_sprite1:setLocalZOrder(10)
    --local top_sprite2 = scroll_container:getChildByName("top_sprite2")
    --top_sprite2:setLocalZOrder(10)
    --self.tab_scroll = createScrollView(scroll_container:getContentSize().width,scroll_container:getContentSize().height,0,0,scroll_container,ccui.ScrollViewDir.horizontal)
end

function WelfareMainWindow:openRootWnd(bid)
    local index = 1
    for i,v in pairs(self.sheet_btn_list) do
        if v.bid == bid then
            index = i
            break
        end
    end

    self.sheet = nil
    local config = Config.HolidayClientData.data_info[self.sheet_btn_list[index].bid]
    if config == nil then
        Debug.error("找不到活动配置！！holiday_client_data.xml id:"..self.sheet_btn_list[index].bid)
    else
        local status, lock_tips = MainuiController:getInstance():checkIsOpenByActivate(config.open_lev)
        if status == true then
            self.sheet = index
        end
    end

    local bind_data = controller:getBindPhoneData()
    if bind_data ~= nil and bind_data.status == 2 then--已领取
        self.sheet_btn_list[2]:setVisible(false)
        self.sheet_btn_list[3]:setPositionY(442)
        self.sheet_btn_list[4]:setPositionY(361)
        self.sheet_btn_list[5]:setPositionY(280)
    else
        self.sheet_btn_list[2]:setVisible(true)
        self.sheet_btn_list[3]:setPositionY(361)
        self.sheet_btn_list[4]:setPositionY(280)
        self.sheet_btn_list[5]:setPositionY(199)
    end

    local grow_fund_data = action_controller:getActionSubTabVo(991008)
    if grow_fund_data == nil then
        self.sheet_btn_list[5]:setPositionY(self.sheet_btn_list[4]:getPositionY())
        self.sheet_btn_list[4]:setPositionY(self.sheet_btn_list[3]:getPositionY())
        self.sheet_btn_list[3]:setVisible(false)
    else
        self.sheet_btn_list[3]:setVisible(true)
    end

    if self.sheet == 2 then
        if self.sheet_btn_list[2]:isVisible() == false then
            self.sheet = nil
        end
    elseif self.sheet == 3 then
        if self.sheet_btn_list[3]:isVisible() == false then
            self.sheet = nil
        end
    end

    if self.sheet == nil then
        for i,v in pairs(self.sheet_btn_list) do
            if v:isVisible() == true then
                local config = Config.HolidayClientData.data_info[v.bid]
                if config == nil then
                    Debug.error("找不到活动配置！！holiday_client_data.xml id:"..v.bid)
                else
                    local status, lock_tips = MainuiController:getInstance():checkIsOpenByActivate(config.open_lev)
                    if status == true then
                        self.sheet = i
                        break
                    end
                end
            end
        end
    end

    for i, sheet_item in pairs(self.sheet_btn_list) do
        -- 设置红点状态
        self:setTabStatus(sheet_item.bid)
    end

    self.sheet = self.sheet or 1
    self:setSheetType()

    if self.sheet_btn_list[3]:isVisible() == true then
        action_controller:cs16603(ActionSpecialID.growfund)
    end

    --self.sub_list = controller:getWelfareSubList()
    --self.auto_bid = bid or WelfareIcon.sign
    --
    --Debug.info(self.sub_list)
    --self:createSubType()
    ActionController:getInstance():sender24700()
end

function WelfareMainWindow:createSubType()
	if self.sub_list == nil or next(self.sub_list) == nil then

    else
        local sum = #self.sub_list
        local max_width = sum * (self.tab_width + self.off_space) + self.off_space
        self.max_width = math.max(self.tab_scroll:getContentSize().width,max_width)
        self.tab_scroll:setInnerContainerSize(cc.size(self.max_width,self.tab_scroll:getContentSize().height))

        local function call_back(item)
            if item:getData().bid == WelfareIcon.quest then
                controller:openSureveyQuestView(true)
            else
                self:handleSelectedTab(item)
            end
        end
        local index_selected = 0
        local tab_item, _x, _y, data = nil, 2
        for i=1,sum do
            data = self.sub_list[i]
            if data ~= nil and data.bid ~= nil and self.tab_list[data.bid] == nil then
                tab_item = WelfareTab.new()
                tab_item:setData(data)
                _x = self.off_space+(i-1)*(self.tab_width+self.off_space)
                tab_item:setPosition(_x,79)
                tab_item:setClickCallBack(call_back)
                self.tab_scroll:addChild(tab_item)
                self.tab_list[data.bid] = tab_item
                if self.auto_bid ~= nil then
                    if self.auto_bid == data.bid then
                        index_selected = i
                    end
                end
                -- 设置红点状态
                self:setTabStatus(data.bid)
            end
        end

        if index_selected == 0 then
            index_selected = 1
        end
        -- 手动设置选中第一个
        data = self.sub_list[index_selected]
        if data ~= nil then
            if index_selected and index_selected ~= 1 then
                self.tab_scroll:scrollToPercentHorizontal(math.ceil(100*index_selected/sum),1,true)
            end
            self:handleSelectedTab(self.tab_list[data.bid])
        end
    end
end

--==============================--
--desc:设置标签页红点状态
--time:2017-08-31 03:25:54
--@bid:
--@return 
--==============================--
function WelfareMainWindow:setTabStatus(bid)
    if self.sheet == nil or self.sheet_btn_list == nil then return end

    local vo = controller:getWelfareStatusByID(bid)
    if action_controller:isSpecialBid(bid) then
        vo = action_controller:getHolidayAweradsStatus(bid)
    end

    local redpoint = false
    --local tab_item = self.tab_list[bid]
    --if tab_item == nil then return end
    if vo == nil or vo.status == false then
        --if tab_item.updateTipsStatus then
        --    tab_item:updateTipsStatus(false)
        --end
    else
        redpoint = true
        --if tab_item.updateTipsStatus then
        --    tab_item:updateTipsStatus(true)
        --end
    end

    --Debug.info(bid)
    --Debug.info(redpoint)

    for i,v in pairs(self.sheet_btn_list) do
        if v.bid == bid then
            if redpoint == true and v.redpoint_spine == nil then
                v.redpoint_spine = PathTool.gw_createRedpointSpine()
                v.redpoint:addChild(v.redpoint_spine)
            end
            v.redpoint:setVisible(redpoint)
            break
        end
    end

end

function WelfareMainWindow:handleSelectedTab(tab)
    if self.selected_tab ~= nil and self.selected_tab == tab then return end
    if self.selected_tab ~= nil then
        self.selected_tab:setSelecte(false)
    end
    self.selected_tab = tab
    if self.selected_tab ~= nil then
        self.selected_tab:setSelecte(true)
    end
    self:changePanelByTab()
end

function WelfareMainWindow:changePanelByTab()
    if self.selected_tab == nil or self.selected_tab.data == nil then return end

    local data = self.selected_tab.data
    if data.bid == nil or data.bid == 0 then return end
    if data.panel_type == nil or data.panel_type == 0 or WelfarePanelTypeView[data.panel_type] == nil then return end
    if data.bid == WelfareIcon.subscribe then   --点击订阅预览按钮取消红点
        controller:sender10988()
    end

    if self.selected_panel ~= nil then
        if self.selected_panel.setVisibleStatus then
            self.selected_panel:setVisibleStatus(false)
        else
            self.selected_panel:setVisible(false)
        end
        self.selected_panel = nil
    end

    if self.panel_list[data.bid] == nil then
        local view_str = WelfarePanelTypeView[data.panel_type]
        if _G[view_str] then
            self.panel_list[data.bid] = (_G[view_str]).new(data.bid)
            self.container:addChild(self.panel_list[data.bid])
        end
    end
    self.selected_panel = self.panel_list[data.bid]
    
    if self.selected_panel then
        if self.selected_panel.setVisibleStatus then
            self.selected_panel:setVisibleStatus(true)
        else
            self.selected_panel:setVisible(true)
        end
    end
end

function WelfareMainWindow:register_event(  )
    --registerButtonEventListener(self.close_btn, function()
    --    controller:openMainWindow(false)
    --end,true, 2)

    self:addGlobalEvent(WelfareEvent.UPDATE_WELFARE_TAB_STATUS, function(vo)
        self:setTabStatus(vo.bid)
    end)
    self:addGlobalEvent(ActionEvent.UPDATE_HOLIDAY_TAB_STATUS, function(function_id, vo)
        if not action_controller:isSpecialBid(vo.bid) then return end
        self:setTabStatus(vo.bid)
    end)


    if self.update_supre_event == nil then
        self.update_supre_event = GlobalEvent:getInstance():Bind(WelfareEvent.Update_Yueka, function(data)
            self:refreshSheet1ContainerData(data)
        end)
    end

    self.update_get_supre_event = GlobalEvent:getInstance():Bind(WelfareEvent.Update_Get_Yueka, function(_type)
        if self.sheet == nil or self.sheet ~= 1 then return end
        if _type == 1 then--至尊月卡领取成功
            self.sheet1_type_list[2].current_day = self.sheet1_type_list[2].current_day + 1
            self.sheet1_type_list[2].get_btn:setVisible(false)
            self.sheet1_type_list[2].getted_btn:setVisible(true)
            self.sheet1_type_list[2].tips4:setString(string.format(UI_TI18N(43001), self.sheet1_type_list[2].current_day))

        elseif _type == 2 then--荣耀月卡领取成功
            self.sheet1_type_list[1].current_day = self.sheet1_type_list[1].current_day + 1
            self.sheet1_type_list[1].get_btn:setVisible(false)
            self.sheet1_type_list[1].getted_btn:setVisible(true)
            self.sheet1_type_list[1].tips4:setString(string.format(UI_TI18N(43001), self.sheet1_type_list[1].current_day))
        end
        --self:refreshSheet1Container()
    end)

    if gw_role_vo then
        if self.role_update_event == nil then
            self.role_update_event = gw_role_vo:Bind(RoleEvent.UPDATE_ROLE_ATTRIBUTE, function(key, value)
                if key == "vip_exp" then
                    self:refreshSheet1Container()
                end
            end)
        end
    end

    if self.bind_phone_event == nil then
        self.bind_phone_event = GlobalEvent:getInstance():Bind(WelfareEvent.UpdateBindPhoneStatus, function()
            self:refreshSheet2Container()
        end)
    end

    if not self.update_action_even_event then
        self.update_action_even_event = GlobalEvent:getInstance():Bind(ActionEvent.UPDATE_HOLIDAY_SIGNLE,function(data)
            if data.bid == 991008 then
                self:refreshSheet3ContainerData(data)
                --Debug.info(data)
                --self:createList(data)
                self:checkTabIconStatus()
            end
        end)
    end
end

function WelfareMainWindow:close_callback()
    if self.gw_subscription_panel then
        if self.gw_subscription_panel.DeleteMe then
            self.gw_subscription_panel:DeleteMe()
        end
        self.gw_subscription_panel = nil
    end
    --for k,v in pairs(self.panel_list) do
    --    if v.DeleteMe then
    --        v:DeleteMe()
    --    end
    --end
    --self.panel_list = nil
    --
    --for k,v in pairs(self.tab_list) do
    --    if v.DeleteMe then
    --        v:DeleteMe()
    --    end
    --end
    --self.tab_list = nil
    self.sheet = nil

    if self.sheet_btn_list ~= nil then
        for i,v in pairs(self.sheet_btn_list) do
            if v.redpoint_spine ~= nil then
                v.redpoint_spine:clearTracks()
                v.redpoint_spine:removeFromParent()
                v.redpoint_spine = nil
            end
        end
        self.sheet_btn_list = nil
    end

    if self.role_update_event then
        GlobalEvent:getInstance():UnBind(self.role_update_event)
        self.role_update_event = nil
    end
    if self.background_load then
        self.background_load:DeleteMe()
        self.background_load = nil
    end
    if self.sheet1_bg_load ~= nil then
        self.sheet1_bg_load:DeleteMe()
        self.sheet1_bg_load = nil
    end
    self.sheet1_bg = nil
    if self.sheet2_bg_load ~= nil then
        self.sheet2_bg_load:DeleteMe()
        self.sheet2_bg_load = nil
    end
    self.sheet2_bg = nil
    if self.sheet3_bg_load ~= nil then
        self.sheet3_bg_load:DeleteMe()
        self.sheet3_bg_load = nil
    end
    self.sheet3_bg = nil
    if self.sheet4_bg_load ~= nil then
        self.sheet4_bg_load:DeleteMe()
        self.sheet4_bg_load = nil
    end
    self.sheet4_bg = nil
    if self.sheet4_item_list then
        for k,v in pairs(self.sheet4_item_list) do
            v:DeleteMe()
        end
        self.sheet4_item_list = nil
    end
    if self.sheet2_item_list then
        for k,v in pairs(self.sheet2_item_list) do
            v:DeleteMe()
        end
        self.sheet2_item_list = nil
    end

    if self.sheet3_scroll_view ~= nil then
        self.sheet3_scroll_view:DeleteMe()
        self.sheet3_scroll_view = nil
    end
    if self.send_buy_growfund_ticket ~= nil then
        GlobalTimeTicket:getInstance():remove(self.send_buy_growfund_ticket)
        self.send_buy_growfund_ticket = nil
    end

	controller:openMainWindow(false)
end

function WelfareMainWindow:checkTabIconStatus(data)
    --未激活的时候
    if SysEnv:getInstance():getBool(SysEnv.keys.grow_fund_redpoint, true) then
        ActionController:getInstance():setHolidayStatus(ActionSpecialID.growfund, false)
        --if self.holiday_bid == ActionSpecialID.growfund then
            WelfareController:getInstance():setWelfareStatus(ActionSpecialID.growfund, false)
        --end
        SysEnv:getInstance():set(SysEnv.keys.grow_fund_redpoint, false)
    end
end
function WelfareMainWindow:createSheetBtnList()

end
function WelfareMainWindow:onClickSheet(index)
    if self.sheet == nil then return end

    if self.sheet == index then return end

    local config = Config.HolidayClientData.data_info[self.sheet_btn_list[index].bid]
    if config == nil then
        Debug.error("找不到活动配置！！holiday_client_data.xml id:"..self.sheet_btn_list[index].bid)
        return
    end

    local status, lock_tips = MainuiController:getInstance():checkIsOpenByActivate(config.open_lev)
    if status == false then
        message(lock_tips)
        return
    end

    self.sheet = index

    self:setSheetType()
end
function WelfareMainWindow:setSheetType()
    if self.sheet == nil then return end

    for i,v in pairs(self.sheet_btn_list) do
        if i==self.sheet then
            v.normal:setVisible(false)
            v.select:setVisible(true)
            v:setTouchEnabled(false)
        else
            v.normal:setVisible(true)
            v.select:setVisible(false)
            v:setTouchEnabled(true)
        end
    end

    self:refreshSheet1Container()
    self:refreshSheet2Container()
    self:refreshSheet3Container()
    self:refreshSheet4Container()
    self:refreshSubscriptionPanel()
end
function WelfareMainWindow:refreshSheet1Container()
    if self.sheet == nil then return end

    if self.sheet ~= 1 then
        self.sheet1_container:setVisible(false)
        return
    end

    controller:sender16705()
end
function WelfareMainWindow:refreshSheet1ContainerData(data)
    if self.sheet == nil then return end

    if self.sheet ~= 1 then return end

    if self.sheet1_bg == nil then
        self.sheet1_bg = self.sheet1_container:getChildByName("bg")
        local bg_res = PathTool.getPlistImgForDownLoad("gw_welfare", "gw_welfare_05", false)
        if not self.sheet1_bg_load then
            self.sheet1_bg_load = loadSpriteTextureFromCDN(self.sheet1_bg, bg_res, ResourcesType.single, self.sheet1_bg_load)
        end

        local type_bid_list = {WelfareIcon.honor_yueka,WelfareIcon.supre_yueka}
        self.sheet1_type_list = {}
        for i=1,2 do
            self.sheet1_type_list[i] = self.sheet1_container:getChildByName("type"..i)
            self.sheet1_type_list[i].bid = type_bid_list[i]
            self.sheet1_type_list[i].title = self.sheet1_type_list[i]:getChildByName("title")
            local type_config = Config.HolidayClientData.data_info[self.sheet1_type_list[i].bid]
            if type_config == nil then
                Debug.error("找不到活动配置！！holiday_client_data.xml ID:"..self.sheet1_type_list[i].bid)
            else
                self.sheet1_type_list[i].title:setString(type_config.title)
            end
            local tips1_node = self.sheet1_type_list[i]:getChildByName("tips1_node")
            self.sheet1_type_list[i].tips1 = createRichLabel(26, cc.c3b(0x40, 0x43,0x4d), cc.p(0, 0.5), cc.p(0, 0), nil, nil, 400)
            tips1_node:addChild(self.sheet1_type_list[i].tips1)
            local tips2_node = self.sheet1_type_list[i]:getChildByName("tips2_node")
            self.sheet1_type_list[i].tips2 = createRichLabel(22, cc.c3b(0x40, 0x43,0x4d), cc.p(0, 0.5), cc.p(0, 0), nil, nil, 400)
            tips2_node:addChild(self.sheet1_type_list[i].tips2)
            local tips3_node = self.sheet1_type_list[i]:getChildByName("tips3_node")
            self.sheet1_type_list[i].tips3 = createRichLabel(26, cc.c3b(0x40, 0x43,0x4d), cc.p(0.5, 0.5), cc.p(0, 0), nil, nil, 400)
            tips3_node:addChild(self.sheet1_type_list[i].tips3)
            local tips4_node = self.sheet1_type_list[i]:getChildByName("tips4_node")
            self.sheet1_type_list[i].tips4 = createRichLabel(22, cc.c3b(0x60, 0x61,0x64), cc.p(0.5, 0.5), cc.p(0, 0), nil, nil, 400)
            tips4_node:addChild(self.sheet1_type_list[i].tips4)
            self.sheet1_type_list[i].getted_btn = self.sheet1_type_list[i]:getChildByName("getted_btn")
            self.sheet1_type_list[i].getted_btn:setVisible(false)
            self.sheet1_type_list[i].getted_btn:getChildByName("label"):setString(UI_TI18N(43002))
            self.sheet1_type_list[i].get_btn = self.sheet1_type_list[i]:getChildByName("get_btn")
            self.sheet1_type_list[i].get_btn:addTouchEventListener(function(sender, event_type)
                customClickAction_4(sender,event_type)
                if event_type == ccui.TouchEventType.ended then
                    playButtonSound2()
                    if i==1 then
                        controller:sender16706(2)
                    else
                        controller:sender16706(1)
                    end
                end
            end)
            self.sheet1_type_list[i].get_btn:setVisible(false)
            self.sheet1_type_list[i].get_btn:getChildByName("label"):setString(UI_TI18N(43003))
            self.sheet1_type_list[i].go_to_charge_btn = self.sheet1_type_list[i]:getChildByName("go_to_charge_btn")
            self.sheet1_type_list[i].go_to_charge_btn:addTouchEventListener(function(sender, event_type)
                customClickAction_4(sender,event_type)
                if event_type == ccui.TouchEventType.ended then
                    playButtonSound2()
                    VipController:getInstance():openVipMainWindow(true, VIPTABCONST.CHARGE)
                end
            end)
            self.sheet1_type_list[i].go_to_charge_btn:setVisible(false)
            self.sheet1_type_list[i].go_to_charge_btn:getChildByName("label"):setString(UI_TI18N(43004))

            self.sheet1_type_list[i].bar_bg = self.sheet1_type_list[i]:getChildByName("bar_bg")
            self.sheet1_type_list[i].bar = self.sheet1_type_list[i]:getChildByName("bar")
            self.sheet1_type_list[i].bar:setScale9Enabled(true)
        end
    end

    if data == nil then
        Debug.error("月卡返回数据错误！！！协议号：16705")
        self.sheet1_container:setVisible(false)
        return
    end

    local role_vo = RoleController:getInstance():getRoleVo()
    local now_time = GameNet:getInstance():getSrvLocalTime()
    local last_time_list = SysEnv:getInstance():getTable(SysEnv.keys.gw_yueka_open_time)
    if last_time_list[role_vo.uid] == nil or TimeTool.gwIsToday(last_time_list[role_vo.uid]) ~= true then
        last_time_list[role_vo.uid] = now_time
        SysEnv:getInstance():set(SysEnv.keys.gw_yueka_open_time, last_time_list, true)
        controller:gw_yuekaRedpointUpdate()
    end

    --荣耀月卡
    local type1_item = self.sheet1_type_list[1]
    local add_count = Config.ChargeData.data_constant.month_card2_sun.val
    local acc_count = data.card2_acc
    local add_get_day_2 = Config.ChargeData.data_constant.month_card2_cont_day.val
    local item_bid_2 = Config.ChargeData.data_constant.month_card2_items.val[1][1]
    local item_num_2 = Config.ChargeData.data_constant.month_card2_items.val[1][2]
    local item_config = Config.ItemData.data_get_data(item_bid_2)
    type1_item.current_day = data.card2_days
    type1_item.tips1:setString(string.format(UI_TI18N(43005), add_count))
    type1_item.tips2:setString(string.format(UI_TI18N(43006), add_get_day_2))
    local cost_str = string.format("<div fontsize=30>%d</div><img src='%s' scale=0.4 />", item_num_2, PathTool.getItemRes(item_config.icon))
    type1_item.tips3:setString(string.format(UI_TI18N(43007), cost_str))
    if data.card2_is_reward == 0 then--未激活
        type1_item.tips4:setString(string.format(UI_TI18N(43008), acc_count, add_count))
        type1_item.bar:setPercent(math.floor(acc_count/add_count *100))
        type1_item.getted_btn:setVisible(false)
        type1_item.get_btn:setVisible(false)
        type1_item.go_to_charge_btn:setVisible(true)
        type1_item.bar_bg:setVisible(true)
        type1_item.bar:setVisible(true)
    else--已激活
        type1_item.tips4:setString(string.format(UI_TI18N(43001), data.card2_days))

        if data.card2_is_reward == 1 then--可领取
            type1_item.getted_btn:setVisible(false)
            type1_item.get_btn:setVisible(true)
        else--已领取
            type1_item.getted_btn:setVisible(true)
            type1_item.get_btn:setVisible(false)
        end

        type1_item.go_to_charge_btn:setVisible(false)
        type1_item.bar_bg:setVisible(false)
        type1_item.bar:setVisible(false)
    end

    --至尊月卡
    local type2_item = self.sheet1_type_list[2]
    local add_count = Config.ChargeData.data_constant.month_card1_sun.val
    local acc_count = data.card1_acc
    local add_get_day_2 = Config.ChargeData.data_constant.month_card1_cont_day.val
    local item_bid_2 = Config.ChargeData.data_constant.month_card1_items.val[1][1]
    local item_num_2 = Config.ChargeData.data_constant.month_card1_items.val[1][2]
    local item_config = Config.ItemData.data_get_data(item_bid_2)
    type2_item.current_day = data.card1_days
    type2_item.tips1:setString(string.format(UI_TI18N(43009), add_count))
    type2_item.tips2:setString(string.format(UI_TI18N(43010), add_get_day_2))
    local cost_str = string.format("<div fontsize=30>%d</div><img src='%s' scale=0.4 />", item_num_2, PathTool.getItemRes(item_config.icon))
    type2_item.tips3:setString(string.format(UI_TI18N(43011), cost_str))
    if data.card1_is_reward == 0 then--未激活
        type2_item.tips4:setString(string.format(UI_TI18N(43012), acc_count, add_count))
        type2_item.bar:setPercent(math.floor(acc_count/add_count *100))
        type2_item.getted_btn:setVisible(false)
        type2_item.get_btn:setVisible(false)
        type2_item.go_to_charge_btn:setVisible(true)
        type2_item.bar_bg:setVisible(true)
        type2_item.bar:setVisible(true)
    else--已激活
        type2_item.tips4:setString(string.format(UI_TI18N(43001), data.card1_days))

        if data.card1_is_reward == 1 then--可领取
            type2_item.getted_btn:setVisible(false)
            type2_item.get_btn:setVisible(true)
        else--已领取
            type2_item.getted_btn:setVisible(true)
            type2_item.get_btn:setVisible(false)
        end

        type2_item.go_to_charge_btn:setVisible(false)
        type2_item.bar_bg:setVisible(false)
        type2_item.bar:setVisible(false)
    end

    self.sheet1_container:setVisible(true)
end
function WelfareMainWindow:refreshSheet2Container()
    if self.sheet == nil then return end

    if self.sheet ~= 2 then
        self.sheet2_container:setVisible(false)
        return
    end

    if self.sheet2_bg == nil then
        self.sheet2_bg = self.sheet2_container:getChildByName("bg")
        local bg_res = PathTool.getPlistImgForDownLoad("gw_welfare", "gw_welfare_16", false)
        if not self.sheet2_bg_load then
            self.sheet2_bg_load = loadSpriteTextureFromCDN(self.sheet2_bg, bg_res, ResourcesType.single, self.sheet2_bg_load)
        end

        self.sheet2_get_btn = self.sheet2_container:getChildByName("get_btn")
        self.sheet2_get_btn:addTouchEventListener(function(sender, event_type)
            customClickAction_4(sender,event_type)
            if event_type == ccui.TouchEventType.ended then
                playButtonSound2()
                controller:requestBindPhone("", "", "")
            end
        end)
        self.sheet2_get_btn:setVisible(false)
        self.sheet2_get_btn:getChildByName("label"):setString(UI_TI18N(43021))
        self.sheet2_go_to_blind_btn = self.sheet2_container:getChildByName("go_to_blind_btn")
        self.sheet2_go_to_blind_btn:addTouchEventListener(function(sender, event_type)
            customClickAction_4(sender,event_type)
            if event_type == ccui.TouchEventType.ended then
                playButtonSound2()
                LoginController:getInstance():gw_openPhoneBindWindow(false)
                LoginController:getInstance():gw_openPhoneBindWindow(true)
                --LoginController:getInstance():gw_openPhoneCheckWindow(GW_PhoneCheckWindow.type.blind_phone)--打开手机验证面板
                --WelfareController:getInstance():openCertifyBindPhoneWindow(true)
            end
        end)
        self.sheet2_go_to_blind_btn:setVisible(false)
        self.sheet2_go_to_blind_btn:getChildByName("label"):setString(UI_TI18N(43022))
        self.sheet2_getted_btn = self.sheet2_container:getChildByName("getted_btn")
        self.sheet2_getted_btn:setVisible(false)
        self.sheet2_getted_btn:getChildByName("label"):setString(UI_TI18N(43023))

        local bind_data = controller:getBindPhoneData()
        if bind_data ~= nil and bind_data.items ~= nil then
            local item_node = self.sheet2_container:getChildByName("item_node")
            local count = #bind_data.items
            local start_x = 0 -- -148*(count-1)*0.5
            self.sheet2_item_list = {}
            for i, v in ipairs(bind_data.items) do
                local item = self.sheet2_item_list[i]
                if item == nil then
                    item = GW_GoodsItem3.new(true,true)
                    item:gw_showShadow()
                    item:setDefaultTip(true)
                    item:setScale(1)
                    item:setAnchorPoint(0.5,0.5)
                    item:setPosition(0,0)
                    item:setTouchEnabled(true)
                    item:setSwallowTouches(false)
                    item_node:addChild(item)
                    item:setPosition(cc.p(start_x + 148*(i-1), 0))
                    self.sheet2_item_list[i] = item
                end

                item:setBaseData(v.bid, v.num)
            end
        end
    end

    local role_vo = RoleController:getInstance():getRoleVo()
    local now_time = GameNet:getInstance():getSrvLocalTime()
    local last_time_list = SysEnv:getInstance():getTable(SysEnv.keys.gw_bind_phone_open_time)
    if last_time_list[role_vo.uid] == nil or TimeTool.gwIsToday(last_time_list[role_vo.uid]) ~= true then
        last_time_list[role_vo.uid] = now_time
        SysEnv:getInstance():set(SysEnv.keys.gw_bind_phone_open_time, last_time_list, true)
        controller:gw_phoneBindRedpointUpdate()
    end

    local bind_data = controller:getBindPhoneData()
    if bind_data ~= nil and bind_data.status == 2 then--已领取
        self.sheet2_get_btn:setVisible(false)
        self.sheet2_go_to_blind_btn:setVisible(false)
        self.sheet2_getted_btn:setVisible(true)
    elseif bind_data ~= nil and bind_data.status == 1 then--可领取
        self.sheet2_get_btn:setVisible(true)
        self.sheet2_go_to_blind_btn:setVisible(false)
        self.sheet2_getted_btn:setVisible(false)
    else--未绑定
        self.sheet2_get_btn:setVisible(false)
        self.sheet2_go_to_blind_btn:setVisible(true)
        self.sheet2_getted_btn:setVisible(false)
    end

    self.sheet2_container:setVisible(true)
end
function WelfareMainWindow:refreshSheet3Container()
    if self.sheet == nil then return end

    if self.sheet ~= 3 then
        self.sheet3_container:setVisible(false)
        return
    end

    if self.sheet3_bg == nil then
        self.sheet3_bg = self.sheet3_container:getChildByName("bg")
        local bg_res = PathTool.getPlistImgForDownLoad("gw_welfare", "gw_welfare_17", false)
        if not self.sheet3_bg_load then
            self.sheet3_bg_load = loadSpriteTextureFromCDN(self.sheet3_bg, bg_res, ResourcesType.single, self.sheet3_bg_load)
        end
    end

    if self.sheet3_get_data_flag == nil then
        action_controller:cs16603(ActionSpecialID.growfund)
        return
    end

    self.sheet3_container:setVisible(true)
end
function WelfareMainWindow:refreshSheet3ContainerData(data)
    if self.sheet == nil then return end

    if self.sheet ~= 3 then
        self.sheet3_container:setVisible(false)
        return
    end

    if data == nil or data.aim_list == nil then
        self.sheet3_container:setVisible(false)
        return
    end

    self.sheet3_get_data_flag = true

    if self.sheet3_list_container == nil then
        --self.sheet3_bg = self.sheet3_container:getChildByName("bg")
        --local bg_res = PathTool.getPlistImgForDownLoad("gw_welfare", "gw_welfare_17", false)
        --if not self.sheet3_bg_load then
        --    self.sheet3_bg_load = loadSpriteTextureFromCDN(self.sheet3_bg, bg_res, ResourcesType.single, self.sheet3_bg_load)
        --end
        self.sheet3_list_container = self.sheet3_container:getChildByName("list_container")
        local tips1_node = self.sheet3_container:getChildByName("tips1_node")
        self.sheet3_tips1 = createRichLabel(30, cc.c3b(0xff, 0xff,0xff), cc.p(0, 0.5), cc.p(0, 0), nil, nil, 800)
        tips1_node:addChild(self.sheet3_tips1)
        local str = UI_TI18N(43013)
        self.sheet3_tips1:setString(str)
        local tips2_node = self.sheet3_container:getChildByName("tips2_node")
        self.sheet3_tips2 = createRichLabel(26, cc.c3b(0xff, 0xff,0xff), cc.p(0, 0.5), cc.p(0, 0), nil, nil, 800)
        tips2_node:addChild(self.sheet3_tips2)
        local str = UI_TI18N(43014)
        self.sheet3_tips2:setString(str)

        self.sheet3_price_label = self.sheet3_container:getChildByName("price_label")
        local config = Config.ChargeData.data_charge_data[101]
        local val = 88
        if config then
            val = config.val
        end
        local label_str = string.format(UI_TI18N(43015), val)
        self.sheet3_price_label:setString(label_str)
        self.sheet3_buy_btn = self.sheet3_container:getChildByName("buy_btn")
        self.sheet3_buy_btn:addTouchEventListener(function(sender, event_type)
            customClickAction_4(sender,event_type)
            if event_type == ccui.TouchEventType.ended then
                playButtonSound2()
                local config = Config.ChargeData.data_charge_data[101]
                if config and self.touch_buy_growfund == true then
                    self.touch_buy_growfund = nil
                    VipController:getInstance():gw_openGiftPayTypeSelectWindow(true, GW_GIFT_TYPE.GrowthFund, config.id)
                    --sdkOnPay(charge_config.val, 1, charge_config.id, charge_config.name, charge_config.name)
                    --sdkOnPay(config.val, nil, config.id, config.name)
                    if self.send_buy_growfund_ticket ~= nil then
                        GlobalTimeTicket:getInstance():remove(self.send_buy_growfund_ticket)
                        self.send_buy_growfund_ticket = nil
                    end

                    if self.send_buy_growfund_ticket == nil then
                        self.send_buy_growfund_ticket = GlobalTimeTicket:getInstance():add(function()
                            self.touch_buy_growfund = true
                            if self.send_buy_growfund_ticket ~= nil then
                                GlobalTimeTicket:getInstance():remove(self.send_buy_growfund_ticket)
                                self.send_buy_growfund_ticket = nil
                            end
                        end,2)
                    end
                end
            end
        end)
        self.sheet3_buy_btn:setVisible(false)
        self.sheet3_buy_btn:getChildByName("label"):setString(UI_TI18N(43016))
        self.sheet3_buyed_btn = self.sheet3_container:getChildByName("buyed_btn")
        self.sheet3_buyed_btn:setVisible(false)
        self.sheet3_buyed_btn:getChildByName("label"):setString(UI_TI18N(43017))
    end


    if self.send_buy_growfund_ticket ~= nil then
        GlobalTimeTicket:getInstance():remove(self.send_buy_growfund_ticket)
        self.send_buy_growfund_ticket = nil
    end

    local can_buy = (data.finish == FALSE and (next(data.aim_list) ~= nil))
    if can_buy == true then
        self.touch_buy_growfund = true
        self.sheet3_buy_btn:setVisible(true)
        self.sheet3_buyed_btn:setVisible(false)
    else
        self.sheet3_buy_btn:setVisible(false)
        self.sheet3_buyed_btn:setVisible(true)
    end


    local item_list = {}
    for i,v in ipairs(data.aim_list) do
        v.sort_index = 0
        if v.status == ActionStatus.un_finish then
            v.sort_index = 1
        elseif v.status == ActionStatus.finish then
            v.sort_index = 0
        elseif v.status == ActionStatus.completed then
            v.sort_index = 2
        end
        table_insert(item_list, v)
    end

    if next(item_list) == nil then
        --self.empty_tips:setVisible(true)
        if self.sheet3_scroll_view then
            self.sheet3_scroll_view:setVisible(false)
        end
    else
        local sort_func = SortTools.tableLowerSorter({"sort_index", "aim"})
        table_sort(item_list, sort_func)
        if self.sheet3_scroll_view == nil then
            local size = self.sheet3_list_container:getContentSize()
            local setting = {
                item_class = GW_ActionGrowFundItem,
                start_x = 19,
                space_x = 0,
                start_y = 10,
                space_y = 12,
                item_width = 720,
                item_height = 106,
                row = 1,
                col = 1,
                need_dynamic = true
            }
            self.sheet3_scroll_view = CommonScrollViewLayout.new(self.sheet3_list_container, nil, nil, nil, size, setting)
        end
        local function callback(data)
            if data and data.aim then
                action_controller:cs16604(991008, data.aim, 0)
            end
        end
        self.sheet3_scroll_view:setData(item_list, callback)

        --self.empty_tips:setVisible(false)
        self.sheet3_scroll_view:setVisible(true)
    end

    self.sheet3_container:setVisible(true)
end
function WelfareMainWindow:refreshSheet4Container()
    if self.sheet == nil then return end

    if self.sheet ~= 4 then
        self.sheet4_container:setVisible(false)
        return
    end

    if self.sheet4_bg == nil then
        ---- 告诉服务端激活了查看公众号
        --controller:tellServerWechatStatus()

        self.sheet4_bg = self.sheet4_container:getChildByName("bg")
        local bg_res = PathTool.getPlistImgForDownLoad("gw_welfare", "gw_welfare_18_2", false)
        if not self.sheet4_bg_load then
            self.sheet4_bg_load = loadSpriteTextureFromCDN(self.sheet4_bg, bg_res, ResourcesType.single, self.sheet4_bg_load)
        end

        local tips_node = self.sheet4_container:getChildByName("tips_node")
        self.sheet4_tips = createRichLabel(30, cc.c3b(0xc9, 0xd9,0xff), cc.p(0, 0.5), cc.p(0, 0), nil, nil, 800)
        tips_node:addChild(self.sheet4_tips)
        self.sheet4_tips:setString(UI_TI18N(43018))

        local data = controller:gw_getWechatData()
        if data ~= nil and data.items ~= nil then
            local item_node = self.sheet4_container:getChildByName("item_node")
            local count = #data.items
            local start_x = -172*(count-1)*0.5
            self.sheet4_item_list = {}
            for i, v in ipairs(data.items) do
                local item = self.sheet4_item_list[i]
                if item == nil then
                    item = GW_GoodsItem3.new(true,true)
                    item:gw_showShadow()
                    item:setDefaultTip(true)
                    item:setScale(1)
                    item:setAnchorPoint(0.5,0.5)
                    item:setPosition(0,0)
                    item:setTouchEnabled(true)
                    item:setSwallowTouches(false)
                    item_node:addChild(item)
                    item:setPosition(cc.p(start_x + 172*(i-1), 0))
                    self.sheet4_item_list[i] = item
                end

                item:setBaseData(v.bid, v.num)
            end
        end
    end

    self.sheet4_container:setVisible(true)
end
function WelfareMainWindow:refreshSubscriptionPanel()
    if self.sheet == nil then return end

    if self.sheet ~= 5 then
        if self.gw_subscription_panel then
            if self.gw_subscription_panel.setVisibleStatus then
                self.gw_subscription_panel:setVisibleStatus(false)
            else
                self.gw_subscription_panel:setVisible(false)
            end
        end
        return
    end

    if self.gw_subscription_panel == nil then
        self.gw_subscription_panel = SubscriptionPrivilegePanel.new()
        self.panel_container:addChild(self.gw_subscription_panel)
    end

    if self.gw_subscription_panel.setVisibleStatus then
        self.gw_subscription_panel:setVisibleStatus(true)
    else
        self.gw_subscription_panel:setVisible(true)
    end
end



GW_ActionGrowFundItem = class("GW_ActionGrowFundItem", function()
    return ccui.Layout:create()
end)

function GW_ActionGrowFundItem:ctor()
    self.root_wnd = createCSBNote(PathTool.getTargetCSB("welfare/gw_action_grow_fund_item"))
    self.size = self.root_wnd:getContentSize()
    self:setAnchorPoint(cc.p(0.5, 0.5))
    self:setContentSize(self.size)

    self.root_wnd:setAnchorPoint(0.5, 0.5)
    self.root_wnd:setPosition(self.size.width * 0.5, self.size.height * 0.5)
    self:addChild(self.root_wnd)

    self.container = self.root_wnd:getChildByName("container")
    self.title = self.container:getChildByName("title")
    self.title:setString(UI_TI18N(43019))
    self.lev_label = self.container:getChildByName("lev_label")
    self.lev_label:setString(UI_TI18N(43020))
    self.lev = self.container:getChildByName("lev")

    local label_node = self.container:getChildByName("label_node")
    self.reward_label = createRichLabel(32, cc.c3b(0xff, 0xff,0xff), cc.p(1, 0.5), cc.p(0, 0), nil, nil, 600)
    label_node:addChild(self.reward_label)
    self.get_btn = self.container:getChildByName("get_btn")
    self.get_btn:setVisible(false)
    local label = self.get_btn:getChildByName("label")
    label:setString(UI_TI18N(43024))
    label:setFontSize(28)
    if label:getContentSize().width > 170 then
        for k=1,15 do
            label:setFontSize(28-k)
            if label:getContentSize().width <= 170 then
                break
            end
        end
    end
    self.getted_btn = self.container:getChildByName("getted_btn")
    self.getted_btn:setVisible(false)
    self.getted_btn_label = self.getted_btn:getChildByName("label")

    self:registerEvent()

    --self.is_completed = false
end

----==============================--
----desc:设置扩展参数  {node = self.item, count = self.interaction_count}
----time:2018-07-16 09:40:01
----@data:
----@return
----==============================--
--function GW_ActionGrowFundItem:setExtendData(node)
--    if not tolua.isnull(node) and self.root_wnd == nil then
--        self.is_completed = true
--        local size = node:getContentSize()
--        self:setAnchorPoint(cc.p(0.5, 0.5))
--        self:setContentSize(size)
--
--        self.root_wnd = node:clone()
--        self.root_wnd:setVisible(true)
--        self.root_wnd:setAnchorPoint(0.5, 0.5)
--        self.root_wnd:setPosition(size.width * 0.5, size.height * 0.5)
--        self:addChild(self.root_wnd)
--
--        self.title_bg = self.root_wnd:getChildByName("title_bg")
--        self.title = self.root_wnd:getChildByName("title")
--
--        self.get_btn = self.root_wnd:getChildByName("get_btn")
--        self.get_btn_label = self.get_btn:getChildByName("label")
--        self.get_btn_label:setString(TI18N("领取"))
--
--        self.item_icon_1 = self.root_wnd:getChildByName("item_icon_1")
--        self.item_icon_2 = self.root_wnd:getChildByName("item_icon_2")
--        self.item_value_1 = self.root_wnd:getChildByName("item_value_1")
--        self.item_value_2 = self.root_wnd:getChildByName("item_value_2")
--
--        self.pass_icon = self.root_wnd:getChildByName("pass_icon")
--
--        self:registerEvent()
--    end
--end

function GW_ActionGrowFundItem:registerEvent()
    self.get_btn:addTouchEventListener(function(sender, event_type)
        customClickAction_4(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            if self.call_back and self.data then
                self.call_back(self.data)
            end
        end
    end)
end

function GW_ActionGrowFundItem:addCallBack(callback)
    self.call_back = callback
end

function GW_ActionGrowFundItem:setData(data)
    if data then
        self.data = data
        self.lev:setString(data.aim or "")

        if data.status == ActionStatus.un_finish then
            self.get_btn:setVisible(false)
            self.getted_btn_label:setString(UI_TI18N(40003))
            self.getted_btn_label:setFontSize(28)
            if self.getted_btn_label:getContentSize().width > 170 then
                for k=1,15 do
                    self.getted_btn_label:setFontSize(28-k)
                    if self.getted_btn_label:getContentSize().width <= 170 then
                        break
                    end
                end
            end
            self.getted_btn:setVisible(true)
        else
            if data.status ~= ActionStatus.completed then
                self.get_btn:setVisible(true)
                self.getted_btn:setVisible(false)
            else
                self.getted_btn_label:setString(UI_TI18N(43025))
                self.getted_btn_label:setFontSize(28)
                if self.getted_btn_label:getContentSize().width > 170 then
                    for k=1,15 do
                        self.getted_btn_label:setFontSize(28-k)
                        if self.getted_btn_label:getContentSize().width <= 170 then
                            break
                        end
                    end
                end
                self.get_btn:setVisible(false)
                self.getted_btn:setVisible(true)
            end
        end

        local reward_str = ""
        if data.item_list and next(data.item_list) ~= nil then
            if #data.item_list == 1 then
                local bid = data.item_list[1].bid
                local num = data.item_list[1].num or 0
                reward_str = string.format("<img src=%s scale=0.4 />%s", PathTool.getItemRes(bid), num)
            elseif #data.item_list >= 2 then
                local bid = data.item_list[1].bid
                local num = data.item_list[1].num or 0
                local str1 = string.format("<img src=%s scale=0.4 />%s", PathTool.getItemRes(bid), num)
                local bid = data.item_list[2].bid
                local num = data.item_list[2].num or 0
                local str2 = string.format("<img src=%s scale=0.4 />%s", PathTool.getItemRes(bid), num)

                reward_str = string.format("%s  +  %s", str1, str2)
            end
        end
        self.reward_label:setString(reward_str)
    end
    --if data then
    --    self.data = data
    --    self.title:setString(data.aim_str or "")
    --    self.get_btn:setVisible(data.status ~= ActionStatus.completed)
    --    self.pass_icon:setVisible(data.status == ActionStatus.completed)
    --    if data.status == ActionStatus.un_finish then
    --        setChildUnEnabled(true, self.get_btn)
    --        self.get_btn:setTouchEnabled(false)
    --        self.get_btn_label:disableEffect()
    --        self.get_btn_label:setString(TI18N("未达成"))
    --        self.title_bg:setOpacity(255)
    --    elseif data.status == ActionStatus.finish then
    --        setChildUnEnabled(false, self.get_btn)
    --        self.get_btn:setTouchEnabled(true)
    --        self.get_btn_label:enableOutline(Config.ColorData.data_color4[264],2)
    --        self.get_btn_label:setString(TI18N("领取"))
    --        self.title_bg:setOpacity(255)
    --    elseif data.status == ActionStatus.completed then
    --        self.title_bg:setOpacity(128)
    --    end
    --
    --    if data.item_list then
    --        for i,v in ipairs(data.item_list) do
    --            if self["item_icon_"..i] then
    --                self["item_icon_"..i]:loadTexture(PathTool.getItemRes(v.bid), LOADTEXT_TYPE)
    --            end
    --            if self["item_value_"..i] then
    --                self["item_value_"..i]:setString("X"..(v.num or 0))
    --            end
    --        end
    --    end
    --end
end

function GW_ActionGrowFundItem:DeleteMe()
    self:removeAllChildren()
    self:removeFromParent()
end